/***************************************************************************
                          guifile.h  -  description
 ***************************************************************************/

#ifndef GUIFILE_H
#define GUIFILE_H

#include "wire.h"
#include "diagrams/diagram.h"
#include "paintings/painting.h"
#include "components/component.h"


class QTextEdit;
class QProcess;
class QucsDoc;

class QucsFile {
public:
  QucsFile(QucsDoc*);
  ~QucsFile();

  int   save();
  bool  load();

  QString createClipboardFile();
  bool    pasteFromClipboard(QTextStream*, QPtrList<Element_Qucs>*);
  QString createUndoString(char);
  bool    rebuild(QString *);
  QString createSymbolUndoString(char);
  bool    rebuildSymbol(QString *);

  bool  createSubNetlist(QTextStream*, int&, QStringList&, QTextEdit*);
  bool  prepareNetlist(QTextStream&, QStringList&, QTextEdit*);
  void  createNetlist(QTextStream&);


private:
  bool  loadProperties(QTextStream*);
  void  simpleInsertComponent(Component*);
  bool  loadComponents(QTextStream*, QPtrList<Component> *List=0);
  void  simpleInsertWire(Wire*);
  bool  loadWires(QTextStream*, QPtrList<Element_Qucs> *List=0);
  bool  loadDiagrams(QTextStream*, QPtrList<Diagram>*);
  bool  loadPaintings(QTextStream*, QPtrList<Painting>*);
  bool  loadIntoNothing(QTextStream*);

  bool  giveNodeNames(QTextStream*, int&, QStringList&, QTextEdit*);

  QucsDoc  *Doc;
  QPtrList<Wire>      *Wires;
  QPtrList<Node>      *Nodes;
  QPtrList<Component> *Comps;
  QPtrList<Diagram>   *Diags;
  QPtrList<Painting>  *Paints, *SymbolPaints;

};

#endif
