        SUBROUTINE ASCALF(N,EPSMCH,FVECC,JAC,SCALEF)
C
C       FEB. 13, 1991
C
C       THIS SUBROUTINE ESTABLISHES SCALING FACTORS FOR THE
C       RESIDUAL VECTOR IF FUNCTION ADAPTIVE SCALING IS CHOSEN
C       USING INTEGER VARIABLE ITSCLF.
C
C       NOTE: IN QUASI-NEWTON METHODS THE SCALING FACTORS ARE
C             UPDATED ONLY WHEN THE JACOBIAN IS EVALUATED EXPLI-
C             CITLY.
C
C       SCALING FACTORS ARE DETERMINED FROM THE INFINITY NORMS
C       OF THE ROWS OF THE JACOBIAN AND THE VALUES OF THE CURRENT
C       FUNCTION VECTOR, FVECC.
C
C       A MINIMUM TOLERANCE ON THE SCALING FACTOR IS THE SQUARE
C       ROOT OF THE MACHINE PRECISION, SQRTEP.
C
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        DOUBLE PRECISION JAC(N,N)
        DIMENSION        FVECC(N)  ,SCALEF(N)
        DATA ZERO,ONE /0.0D0,1.0D0/
C
        SQRTEP=SQRT(EPSMCH)
C
C       I COUNTS THE ROWS.
C
        DO 100 I=1,N
           AMAX=ZERO
C
C          FIND MAXIMUM ENTRY IN ROW I.
C
           DO 200 J=1,N
              AMAX=MAX(AMAX,ABS(JAC(I,J)))
200        CONTINUE
C
           AMAX=MAX(AMAX,FVECC(I))
C
C          SET SCALING FACTOR TO A DEFAULT OF ONE IF ITH ROW IS ZEROS.
C
           IF(AMAX.EQ.ZERO) AMAX=ONE
           AMAX=MAX(AMAX,SQRTEP)
           SCALEF(I)=ONE/AMAX
100     CONTINUE
        RETURN
C
C       LAST CARD OF SUBROUTINE ASCALF.
C
        END
