        SUBROUTINE CHOLDE(N,MAXADD,MAXFFL,SQRTEP,H,L)
C
C       FEB. 23, 1992
C
C       THIS SUBROUTINE FINDS THE CHOLESKY DECOMPOSITION OF THE
C       MATRIX, H, AND RETURNS IT IN THE LOWER TRIANGLE OF
C       MATRIX, L.
C
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        DOUBLE PRECISION   L(N,N) ,MAXADD ,MAXFFL ,MINL  ,MINL2 ,
     $                     MINLJJ
        DIMENSION          H(N,N)
        DATA ZERO /0.0D0/
C
        MINL=SQRT(SQRTEP)*MAXFFL
C
C       MAXFFL EQUALS 0 WHEN THE MATRIX IS KNOWN TO BE POSITIVE
C       DEFINITE.
C
        IF(MAXFFL.EQ.ZERO) THEN
C
C          FIND SQUARE ROOT OF LARGEST MAGNITUDE DIAGONAL ELEMENT
C          AND SET MINL2.
C
           DO 100 I=1,N
              MAXFFL=MAX(MAXFFL,ABS(H(I,I)))
100        CONTINUE
           MAXFFL=SQRT(MAXFFL)
           MINL2=SQRTEP*MAXFFL
        END IF
C
C       MAXADD CONTAINS THE MAXIMUM AMOUNT WHICH IS IMPLICITLY ADDED
C       TO ANY DIAGONAL ELEMENT OF MATRIX H.
C
        MAXADD=ZERO
        DO 200 J=1,N
           SUM=ZERO
           DO 300 I=1,J-1
	      SUM=SUM+L(J,I)*L(J,I)
300        CONTINUE
           L(J,J)=H(J,J)-SUM
           MINLJJ=ZERO
           DO 400 I=J+1,N
              SUM=ZERO
              DO 500 K=1,J-1
                 SUM=SUM+L(I,K)*L(J,K)
500           CONTINUE
              L(I,J)=H(J,I)-SUM
              MINLJJ=MAX(MINLJJ,ABS(L(I,J)))
400        CONTINUE
           MINLJJ=MAX(MINLJJ/MAXFFL,MINL)
           IF(L(J,J).GT.MINLJJ*MINLJJ) THEN
C
C             NORMAL CHOLESKY DECOMPOSITION.
C
              L(J,J)=SQRT(L(J,J))
           ELSE
C
C             IMPLICITLY PERTURB DIAGONAL OF H.
C
              IF(MINLJJ.LT.MINL2) THEN
                 MINLJJ=MINL2
              END IF
              MAXADD=MAX(MAXADD,MINLJJ*MINLJJ-L(J,J))
              L(J,J)=MINLJJ
           END IF
           DO 600 I=J+1,N
              L(I,J)=L(I,J)/L(J,J)
600        CONTINUE
200     CONTINUE
        RETURN
C
C       LAST CARD OF SUBROUTINE CHOLDE.
C
        END
