        SUBROUTINE DOGLEG(FRSTDG,NEWTKN,OVERCH,OVERFL,MAXEXP,
     $                    N     ,NOTRST,NUNIT ,OUTPUT,BETA  ,
     $                    CAULEN,DELTA ,ETAFAC,NEWLEN,SQRTZ ,
     $                    DELF  ,S     ,SCALEX,SN    ,SSDHAT,
     $                    VHAT  )
C
C       FEB. 23, 1992
C
C       THIS SUBROUTINE FINDS A TRUST REGION STEP USING THE
C       (DOUBLE) DOGLEG METHOD.
C
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        DOUBLE PRECISION LAMBDA   ,NEWLEN
        INTEGER          OUTPUT
        DIMENSION        DELF(N)  ,S(N)    ,SCALEX(N),SN(N)  ,
     $                   SSDHAT(N),VHAT(N)
        LOGICAL          FRSTDG   ,NEWTKN  ,OVERCH   ,OVERFL ,
     $                   WRNSUP
	COMMON/NNES_2/WRNSUP
	DATA ZERO,ONE /0.0D0,1.0D0/
C
        OVERFL=.FALSE.
C
        IF(OUTPUT.GT.3) THEN
           WRITE(NUNIT,1)
1          FORMAT(T3,'*',70X,'*')
           WRITE(NUNIT,2) NOTRST,DELTA
2          FORMAT(T3,'*',4X,'TRUST REGION STEP:',I6,2X,
     $     'TRUST REGION LENGTH, DELTA:',1PD11.3,2X,'*')
           WRITE(NUNIT,1)
           WRITE(NUNIT,3) NEWLEN
3          FORMAT(T3,'*',7X,'LENGTH OF NEWTON STEP, NEWLEN: ',
     $     1PD11.3,21X,'*')
        END IF
C
C       CHECK FOR NEWTON STEP WITHIN TRUST REGION - IF SO USE
C       NEWTON STEP.
C
        IF(NEWLEN.LE.DELTA) THEN
           DO 100 I=1,N
              S(I)=SN(I)
100        CONTINUE
           NEWTKN=.TRUE.
           TEMP=DELTA
           DELTA=NEWLEN
           IF(OUTPUT.GT.3) THEN
              WRITE(NUNIT,1)
              WRITE(NUNIT,4)
4             FORMAT(T3,'*',7X,'NEWTON STEP WITHIN ACCEPTABLE RANGE',
     $        ' ( <= THAN DELTA)',11X,'*')
              IF(TEMP.EQ.DELTA) THEN
                 WRITE(NUNIT,5) DELTA
5                FORMAT(T3,'*',7X,'DELTA STAYS AT LENGTH OF NEWTON',
     $           ' STEP: ',1PD11.3,14X,'*')
              ELSE
                 WRITE(NUNIT,6)
6                FORMAT(T3,'*',7X,'DELTA SET TO LENGTH OF NEWTON',
     $           ' STEP',29X,'*')
              END IF
              WRITE(NUNIT,1)
              WRITE(NUNIT,7)
7             FORMAT(T3,'*',7X,'FULL NEWTON STEP ATTEMPTED',37X,'*')
           END IF
           RETURN
        ELSE
C
C          NEWTON STEP NOT WITHIN TRUST REGION - APPLY (DOUBLE)
C          DOGLEG PROCEDURE.  (IF ETAFAC EQUALS 1.0 THEN THE SINGLE
C          DOGLEG PROCEDURE IS BEING APPLIED).
C
           NEWTKN=.FALSE.
           IF(FRSTDG) THEN
C
C             SPECIAL SECTION FOR FIRST DOGLEG STEP - CALCULATES
C             CAUCHY POINT (MINIMIZER OF MODEL FUNCTION IN STEEPEST
C             DESCENT DIRECTION OF THE OBJECTIVE FUNCTION).
C
              FRSTDG=.FALSE.
              IF(OUTPUT.GT.4) THEN
                 WRITE(NUNIT,1)
		 IF(ETAFAC.EQ.ONE) THEN
                    WRITE(NUNIT,8)
8                   FORMAT(T3,'*',7X,'FIRST SINGLE DOGLEG STEP',
     $              39X,'*')
                 ELSE
                    WRITE(NUNIT,9)
9                   FORMAT(T3,'*',7X,'FIRST DOUBLE DOGLEG STEP',
     $              39X,'*')
                 END IF
                 WRITE(NUNIT,1)
                 WRITE(NUNIT,10)
10                   FORMAT(T3,'*',10X,'SCALED CAUCHY STEP',42X,'*')
                 WRITE(NUNIT,1)
              END IF
C
C             NOTE: BETA AND SQRTZ WERE CALCULATED IN SUBROUTINE DELCAU.
C
              ZETA=SQRTZ*SQRTZ
C
C             FIND STEP TO CAUCHY POINT.
C
              FACTOR=-(ZETA/BETA)
              DO 200 I=1,N
                 SSDHAT(I)=FACTOR*(DELF(I)/SCALEX(I))
                 IF(OUTPUT.GT.4) THEN
                    WRITE(NUNIT,11) I,SSDHAT(I)
11                  FORMAT(T3,'*',13X,'SSDHAT(',I3,') = ',1PD12.3,
     $              31X,'*')
                 END IF
200           CONTINUE
              CALL INNERP(OVERCH,OVERFL,MAXEXP,N,N,N     ,NUNIT ,
     $                    OUTPUT,DELFTS,DELF  ,SN    )
              OVERFL=.FALSE.
C
C             PROTECT AGAINST (RARE) CASE WHEN CALCULATED DIRECTIONAL
C             DERIVATIVE EQUALS ZERO.
C
	      IF(DELFTS.NE.ZERO) THEN
C
C                STANDARD EXECUTION.
C
                 GAMMA=(ZETA/ABS(DELFTS))*(ZETA/BETA)
		 ETA=ETAFAC+(ONE-ETAFAC)*GAMMA
              ELSE
                 IF(OUTPUT.GT.1.AND.(.NOT.WRNSUP)) THEN
                    WRITE(NUNIT,1)
                    WRITE(NUNIT,12)
12                  FORMAT(T3,'*',4X,'WARNING: DELFTS=0; ETA SET',
     $              ' TO 1.0 TO AVOID DIVISION BY ZERO',8X,'*')
                 END IF
		 ETA=ONE
              END IF
              IF(OUTPUT.GT.4) THEN
                 WRITE(NUNIT,1)
                 WRITE(NUNIT,13) ETA
13               FORMAT(T3,'*',10X,'ETA = ',1PD11.3,43X,'*')
                 WRITE(NUNIT,1)
                 WRITE(NUNIT,14)
14               FORMAT(T3,'*',10X,'VHAT VECTOR     VHAT(I)=ETA*',
     $           'SN(I)*SCALEX(I)-SSDHAT(I)',7X,'*')
                 WRITE(NUNIT,1)
              END IF
              DO 300 I=1,N
                 VHAT(I)=ETA*SCALEX(I)*SN(I)-SSDHAT(I)
                 IF(OUTPUT.GT.4) THEN
                    WRITE(NUNIT,15) I,VHAT(I)
15                  FORMAT(T3,'*',13X,'VHAT(',I3,') = ',1PD12.3,
     $              33X,'*')
                 END IF
300           CONTINUE
           END IF
C
C          ETA*NEWLEN <= DELTA MEANS TAKE STEP IN NEWTON DIRECTION
C          TO TRUST REGION BOUNDARY.
C
           IF(ETA*NEWLEN.LE.DELTA) THEN
              IF(OUTPUT.GT.4) THEN
                 WRITE(NUNIT,1)
                 WRITE(NUNIT,16)
16               FORMAT(T3,'*',10X,'ETA*NEWLEN <= DELTA     S(I)',
     $           '= (DELTA/NEWLEN)*SN(I)',10X,'*')
              END IF
              DO 400 I=1,N
                 S(I)=(DELTA/NEWLEN)*SN(I)
400           CONTINUE
           ELSE
C
C             DISTANCE TO CAUCHY POINT >= DELTA MEANS TAKE STEP IN
C             STEEPEST DESCENT DIRECTION TO TRUST REGION BOUNDARY.
C
              IF(CAULEN.GE.DELTA) THEN
                 IF(OUTPUT.GT.4) THEN
                    WRITE(NUNIT,1)
                    WRITE(NUNIT,17)
17                  FORMAT(T3,'*',10X,'CAULEN >= DELTA   S(I)',
     $              '=(DELTA/CAULEN)*(SSDHAT(I)/SCALEX(I))',1X,'*')
                 END IF
                 DO 500 I=1,N
                    S(I)=(DELTA/CAULEN)*(SSDHAT(I)/SCALEX(I))
500              CONTINUE
              ELSE
C
C                TAKE (DOUBLE) DOGLEG STEP.
C
                 CALL INNERP(OVERCH,OVERFL,MAXEXP,N,N,N     ,NUNIT ,
     $                       OUTPUT,TEMP  ,SSDHAT,VHAT  )
                 CALL INNERP(OVERCH,OVERFL,MAXEXP,N,N,N     ,NUNIT ,
     $                       OUTPUT,TEMPV ,VHAT  ,VHAT  )
                 OVERFL=.FALSE.
                 LAMBDA=(-TEMP+SQRT(TEMP*TEMP-TEMPV*(CAULEN*CAULEN
     $                   -DELTA*DELTA)))/TEMPV
                 IF(OUTPUT.GT.4) THEN
                    WRITE(NUNIT,1)
                    WRITE(NUNIT,18)
18                  FORMAT(T3,'*',10X,'S(I)=(SSDHAT(I)+LAMBDA*VHAT(I))',
     $              '/SCALEX(I)',19X,'*')
                    WRITE(NUNIT,1)
                    WRITE(NUNIT,19) LAMBDA
19                  FORMAT(T3,'*',10X,'WHERE LAMBDA = ',1PD12.3,33X,'*')
                 END IF
                 DO 600 I=1,N
                    S(I)=(SSDHAT(I)+LAMBDA*VHAT(I))/SCALEX(I)
600              CONTINUE
              END IF
           END IF
           IF(OUTPUT.GT.3) THEN
              WRITE(NUNIT,1)
              WRITE(NUNIT,1)
              WRITE(NUNIT,20)
20            FORMAT(T3,'*',10X,'REVISED STEP FROM SUBROUTINE',
     $        ' DOGLEG',25X,'*')
              WRITE(NUNIT,1)
              DO 700 I=1,N
                 WRITE(NUNIT,21) I,S(I)
21               FORMAT(T3,'*',13X,'S(',I3,') = ',1PD12.3,36X,'*')
700           CONTINUE
           END IF
        END IF
        RETURN
        END
