        SUBROUTINE INNERP(OVERCH,OVERFL,MAXEXP,LDIMA ,LDIMB ,N     ,
     $                    NUNIT ,OUTPUT,DTPRO ,A     ,B     )
C
C       FEB. 14, 1991
C
C       THIS SUBROUTINE FINDS THE INNER PRODUCT OF TWO VECTORS,
C       A AND B.  IF OVERCH IS FALSE, UNROLLED LOOPS ARE USED.
C
C       LDIMA IS THE DIMENSION OF A
C       LDIMB IS THE DIMENSION OF B
C       N IS THE DEPTH INTO A AND B THE INNER PRODUCT IS DESIRED.
C       (USUALLY LDIMA=LDIMB=N)
C
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        INTEGER    OUTPUT
        DIMENSION  A(LDIMA) ,B(LDIMB)
        LOGICAL    OVERCH   ,OVERFL   ,WRNSUP
        COMMON/NNES_2/WRNSUP
        DATA ZERO,ONE,TEN /0.0D0,1.0D0,10.0D0/
C
        EPS=TEN**(-MAXEXP)
        OVERFL=.FALSE.
C
        DTPRO=ZERO
        IF(OVERCH) THEN
           DO 100 I=1,N
              IF(LOG10(ABS(A(I))+EPS)+LOG10(ABS(B(I))+EPS)
     $           .GT.MAXEXP) THEN
                 OVERFL=.TRUE.
                 DTPRO=SIGN(TEN**MAXEXP,A(I))*SIGN(ONE,B(I))
                 IF(OUTPUT.GT.2.AND.(.NOT.WRNSUP)) THEN
                    WRITE(NUNIT,1)
1                   FORMAT(T3,'*',T74,'*')
                    WRITE(NUNIT,2) DTPRO
2                   FORMAT(T3,'*',4X,'WARNING: TO AVOID OVERFLOW,',
     $              ' INNER PRODUCT SET TO ',1PD12.3,T74,'*')
                 END IF
                 RETURN
              END IF
              DTPRO=DTPRO+A(I)*B(I)
100        CONTINUE
        ELSE
C
C          SET NUMBER OF GROUPS OF EACH SIZE.
C
           NG32=N/32
           NG32R=N-32*NG32
           NG16=NG32R/16
           NG16R=NG32R-16*NG16
           NG8=NG16R/8
           NG8R=NG16R-8*NG8
           NG4=NG8R/4
           NG4R=NG8R-4*NG4
C
C          FIND INNER PRODUCT.
C
           K=0
           IF(NG32.GT.0) THEN
              DO 200 KK=1,NG32
                 K=K+32
                 DTPRO=DTPRO
     $           +A(K-31)*B(K-31)+A(K-30)*B(K-30)
     $           +A(K-29)*B(K-29)+A(K-28)*B(K-28)
     $           +A(K-27)*B(K-27)+A(K-26)*B(K-26)
     $           +A(K-25)*B(K-25)+A(K-24)*B(K-24)
                 DTPRO=DTPRO
     $           +A(K-23)*B(K-23)+A(K-22)*B(K-22)
     $           +A(K-21)*B(K-21)+A(K-20)*B(K-20)
     $           +A(K-19)*B(K-19)+A(K-18)*B(K-18)
     $           +A(K-17)*B(K-17)+A(K-16)*B(K-16)
                 DTPRO=DTPRO
     $           +A(K-15)*B(K-15)+A(K-14)*B(K-14)
     $           +A(K-13)*B(K-13)+A(K-12)*B(K-12)
     $           +A(K-11)*B(K-11)+A(K-10)*B(K-10)
     $           +A(K-9) *B(K-9)  +A(K-8) *B(K-8)
                 DTPRO=DTPRO
     $           +A(K-7)*B(K-7)+A(K-6)*B(K-6)
     $           +A(K-5)*B(K-5)+A(K-4)*B(K-4)
     $           +A(K-3)*B(K-3)+A(K-2)*B(K-2)
     $           +A(K-1)*B(K-1)+A(K)  *B(K)
200           CONTINUE
           END IF
           IF(NG16.GT.0) THEN
              DO 300 KK=1,NG16
                 K=K+16
                 DTPRO=DTPRO
     $           +A(K-15)*B(K-15)+A(K-14)*B(K-14)
     $           +A(K-13)*B(K-13)+A(K-12)*B(K-12)
     $           +A(K-11)*B(K-11)+A(K-10)*B(K-10)
     $           +A(K-9) *B(K-9)  +A(K-8)*B(K-8)
                 DTPRO=DTPRO
     $           +A(K-7)*B(K-7)+A(K-6)*B(K-6)
     $           +A(K-5)*B(K-5)+A(K-4)*B(K-4)
     $           +A(K-3)*B(K-3)+A(K-2)*B(K-2)
     $           +A(K-1)*B(K-1)+A(K)  *B(K)
300           CONTINUE
           END IF
           IF(NG8.GT.0) THEN
              DO 400 KK=1,NG8
                 K=K+8
                 DTPRO=DTPRO
     $           +A(K-7)*B(K-7)+A(K-6)*B(K-6)
     $           +A(K-5)*B(K-5)+A(K-4)*B(K-4)
     $           +A(K-3)*B(K-3)+A(K-2)*B(K-2)
     $           +A(K-1)*B(K-1)+A(K)  *B(K)
400           CONTINUE
           END IF
           IF(NG4.GT.0) THEN
              DO 500 KK=1,NG4
                 K=K+4
                 DTPRO=DTPRO
     $           +A(K-3)*B(K-3)+A(K-2)*B(K-2)
     $           +A(K-1)*B(K-1)+A(K)  *B(K)
500           CONTINUE
           END IF
           IF(NG4R.GT.0) THEN
              DO 600 KK=1,NG4R
                 K=K+1
                 DTPRO=DTPRO+A(K)*B(K)
600           CONTINUE
           END IF
        END IF
        RETURN
C
C       LAST CARD OF SUBROUTINE INNERP.
C
        END
