        SUBROUTINE LSOLV(OVERCH,OVERFL,MAXEXP,N,NUNIT,OUTPUT,L,B,RHS)
C
C       FEB. 14, 1991
C
C       THIS SUBROUTINE SOLVES:
C
C              LB=RHS
C
C              WHERE    L     IS TAKEN FROM THE CHOLESKY DECOMPOSITION
C                       RHS   IS A GIVEN RIGHT HAND SIDE WHICH IS NOT
C                             OVERWRITTEN
C                       B     IS THE SOLUTION VECTOR
C
C       FRSTER IS USED FOR OUTPUT PURPOSES ONLY.
C
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        DOUBLE PRECISION L(N,N)  ,MAXLOG
        INTEGER          OUTPUT
        DIMENSION        B(N)    ,RHS(N)
        LOGICAL          FRSTER  ,OVERCH  ,OVERFL
        DATA ZERO,ONE,TEN /0.0D0,1.0D0,10.0D0/
C
        FRSTER=.TRUE.
        OVERFL=.FALSE.
        EPS=TEN**(-MAXEXP)
C
        IF(OVERCH) THEN
           IF(LOG10(ABS(RHS(1))+EPS)-LOG10(ABS(L(1,1))+EPS)
     $        .GT.MAXEXP) THEN
              OVERFL=.TRUE.
              B(1)=SIGN(TEN**MAXEXP,RHS(1))*
     $                   SIGN(ONE,L(1,1))
              IF(OUTPUT.GT.3) THEN
                 WRITE(NUNIT,1)
1                FORMAT(T3,'*',T74,'*')
                 WRITE(NUNIT,2) 1,B(1)
2                FORMAT(T3,'*',4X,'WARNING: COMPONENT ',I3,
     $           ' SET TO ',1PD11.3,T74,'*')
              END IF
              GO TO 101
           END IF
        END IF
        B(1)=RHS(1)/L(1,1)
101     CONTINUE
        DO 200 I=2,N
           IF(OVERCH) THEN
C
C             CHECK TO FIND IF ANY TERMS IN THE EVALUATION WOULD
C             OVERFLOW.
C
              MAXLOG=LOG10(ABS(RHS(I))+EPS)-LOG10(ABS(L(I,I))+EPS)
              JSTAR=0
              DO 300 J=1,I-1
                 TMPLOG=LOG10(ABS(L(I,J))+EPS)+LOG10(ABS(B(J))+EPS)-
     $                  LOG10(ABS(L(I,I))+EPS)
                 IF(TMPLOG.GT.MAXLOG) THEN
                    JSTAR=J
                    MAXLOG=TMPLOG
                 END IF
300           CONTINUE
C
C             IF AN OVERFLOW WOULD OCCUR ASSIGN A VALUE FOR THE
C             TERM WITH CORRECT SIGN.
C
              IF(MAXLOG.GT.MAXEXP) THEN
                 OVERFL=.TRUE.
                 IF(JSTAR.EQ.0) THEN
                    B(I)=SIGN(TEN**MAXEXP,RHS(I))*
     $                   SIGN(ONE,L(I,I))
                 ELSE
                    B(I)=-SIGN(TEN**MAXEXP,L(I,JSTAR))*
     $                    SIGN(ONE,B(JSTAR))*
     $                    SIGN(ONE,L(I,I))
                 END IF
                 IF(FRSTER) THEN
                    FRSTER=.FALSE.
                    WRITE(NUNIT,1)
                 END IF
                 IF(OUTPUT.GT.3) WRITE(NUNIT,2) I,B(I)
                 GO TO 201
              END IF
           END IF
C
C          SUM FOR EACH TERM, ORDERING OPERATIONS TO MINIMIZE
C          POSSIBILITY OF OVERFLOW.
C
           SUM=ZERO
           DO 400 J=1,I-1
              SUM=SUM+(MIN(ABS(L(I,J)),ABS(B(J)))/L(I,I))*
     $            (MAX(ABS(L(I,J)),ABS(B(J))))*
     $            SIGN(ONE,L(I,J))*SIGN(ONE,B(J))
400        CONTINUE
           B(I)=RHS(I)/L(I,I)-SUM
201     CONTINUE
200     CONTINUE
        RETURN
C
C       LAST CARD OF SUBROUTINE LSOLV.
C
        END
