        SUBROUTINE LTSOLV(OVERCH,OVERFL,MAXEXP,N     ,NUNIT ,
     $                    OUTPUT,L     ,Y     ,B     )
C
C       FEB. 14, 1991
C
C       THIS SUBROUTINE SOLVES:
C
C              L^Y=B
C
C              WHERE    L  IS TAKEN FROM THE CHOLESKY DECOMPOSITION
C                       B  IS A GIVEN RIGHT HAND SIDE WHICH IS NOT
C                          OVERWRITTEN
C                       Y  IS THE SOLUTION VECTOR
C
C       FRSTER IS USED FOR OUTPUT PURPOSES ONLY.
C
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        DOUBLE PRECISION L(N,N)  ,MAXLOG
        INTEGER          OUTPUT
        DIMENSION        B(N)    ,Y(N)
        LOGICAL          FRSTER  ,OVERCH  ,OVERFL
        DATA ZERO,ONE,TEN /0.0D0,1.0D0,10.0D0/
C
        FRSTER=.TRUE.
        OVERFL=.FALSE.
        EPS=TEN**(-MAXEXP)
C
        IF(OVERCH) THEN
           IF(LOG10(ABS(B(N))+EPS)-LOG10(ABS(L(N,N))+EPS)
     $        .GT.MAXEXP) THEN
              OVERFL=.TRUE.
              Y(N)=SIGN(TEN**MAXEXP,B(N))*
     $                   SIGN(ONE,L(N,N))
              IF(OUTPUT.GT.3) THEN
                 FRSTER=.FALSE.
                 WRITE(NUNIT,1)
1                FORMAT(T3,'*',70X,'*')
                 WRITE(NUNIT,2) N,Y(N)
2                FORMAT(T3,'*',4X,'WARNING: COMPONENT ',I3,
     $           ' SET TO ',1PD11.3,25X,'*')
              END IF
              GO TO 101
           END IF
        END IF
        Y(N)=B(N)/L(N,N)
101     CONTINUE
        DO 200 I=N-1,1,-1
           IF(OVERCH) THEN
C
C             CHECK TO FIND IF ANY TERMS IN THE EVALUATION WOULD
C             OVERFLOW.
C
              MAXLOG=LOG10(ABS(B(I))+EPS)-LOG10(ABS(L(I,I))+EPS)
              JSTAR=0
              DO 300 J=I+1,N
                 TMPLOG=LOG10(ABS(L(J,I))+EPS)+LOG10(ABS(Y(J))+EPS)-
     $                  LOG10(ABS(L(I,I))+EPS)
                 IF(TMPLOG.GT.MAXLOG) THEN
                    JSTAR=J
                    MAXLOG=TMPLOG
                 END IF
300           CONTINUE
C
C             IF AN OVERFLOW WOULD OCCUR ASSIGN A VALUE FOR THE
C             TERM WITH CORRECT SIGN.
C
              IF(MAXLOG.GT.MAXEXP) THEN
                 OVERFL=.TRUE.
                 IF(JSTAR.EQ.0) THEN
                    Y(I)=SIGN(TEN**MAXEXP,B(I))*
     $                   SIGN(ONE,L(I,I))
                 ELSE
                    Y(I)=-SIGN(TEN**MAXEXP,L(JSTAR,I))*
     $                          SIGN(ONE,Y(JSTAR))*
     $                    SIGN(ONE,L(I,I))
                 END IF
                 IF(FRSTER) THEN
                    FRSTER=.FALSE.
                    WRITE(NUNIT,1)
                 END IF
                 IF(OUTPUT.GT.3) WRITE(NUNIT,2) I,Y(I)
                 GO TO 201
              END IF
           END IF
C
C          SUM FOR EACH TERM ORDERING OPERATIONS TO MINIMIZE
C          POSSIBILITY OF OVERFLOW.
C
           SUM=ZERO
           DO 400 J=I+1,N
              SUM=SUM+(MIN(ABS(L(J,I)),ABS(Y(J)))/L(I,I))*
     $            (MAX(ABS(L(J,I)),ABS(Y(J))))*
     $            SIGN(ONE,L(J,I))*SIGN(ONE,Y(J))
400        CONTINUE
           Y(I)=B(I)/L(I,I)-SUM
201     CONTINUE
200     CONTINUE
        RETURN
C
C       LAST CARD OF SUBROUTINE LTSOLV.
C
        END
