	SUBROUTINE MATPRT(NROWA,NCOLA,NROWPR,NCOLPR,NUNIT,A)
C
C       FEB. 6, 1991
C
C       THIS SUBROUTINE PRINTS RECTANGULAR BLOCKS STARTING WITH
C       ELEMENT A(1,1) OF SIZE NROWPR BY NCOLPR FOR MATRIX A
C       (WHICH HAS DECLARED SIZE NROWA BY NCOLA). THE MATRIX IS
C       PRINTED AS A BLOCK FOR SIZES UP TO 5X5 OR BY COLUMNS IF
C       IT IS LARGER.
C
C       NROWA IS THE NUMBER OF DECLARED ROWS IN THE MATRIX
C       NCOLA IS THE NUMBER OF DECLARED COLUMNS IN THE MATRIX
C
C       NROWPR IS THE NUMBER OF ROWS TO BE PRINTED
C       NCOLPR IS THE NUMBER OF COLUMNS TO BE PRINTED
C
C       IF MATRIX PRINTING IS TO BE SUPPRESSED THEN LOGICAL
C       VARIABLE MATSUP MUST BE SET TO TRUE BEFORE THE CALL
C       TO NNES.
C
	IMPLICIT DOUBLE PRECISION (A-H,O-Z)
	DOUBLE PRECISION A(NROWA,NCOLA)
	LOGICAL MATSUP
	COMMON/NNES_1/MATSUP
C
	IF(MATSUP) THEN
	   WRITE(NUNIT,1)
1          FORMAT(T3,'*',T74,'*')
	   WRITE(NUNIT,2)
2          FORMAT(T3,'*',7X,'MATRIX PRINTING SUPPRESSED',T74,'*')
	   RETURN
	END IF
C
C       FOR NCOLPR <= 5 WRITE MATRIX AS A WHOLE.
C
	WRITE(NUNIT,1)
	IF(NCOLPR.LE.5) THEN
	   WRITE(NUNIT,3) (K,K=1,NCOLPR)
3          FORMAT(T74,'*',T3,'*',2X,5(I12:))
	   WRITE(NUNIT,1)
	   DO 100 I=1,NROWPR
	      WRITE(NUNIT,4) I,(A(I,K),K=1,NCOLPR)
4             FORMAT(T74,'*',T3,'*',3X,I3,5(1PD12.3:))
100        CONTINUE
        ELSE
C
C          LIMIT IS THE NUMBER OF GROUPS OF 5 COLUMNS.
C
	   LIMIT=NCOLPR/5
C
C          WRITE COMPLETE BLOCKS FIRST (LEFTOVERS LATER).
C
	   DO 200 J=1,LIMIT
	      WRITE(NUNIT,5) (K,K=1+(J-1)*5,5+(J-1)*5)
5             FORMAT(T3,'*',2X,5I12,T74,'*')
	      WRITE(NUNIT,1)
	      DO 300 I=1,NROWPR
		 WRITE(NUNIT,6) I,(A(I,K),K=1+(J-1)*5,5+(J-1)*5)
6                FORMAT(T3,'*',3X,I3,5(1PD12.3),T74,'*')
300           CONTINUE
	      WRITE(NUNIT,1)
200        CONTINUE
C
C          WRITE REMAINING ELEMENTS.
C
	   WRITE(NUNIT,7) (K,K=5*LIMIT+1,NCOLPR)
7          FORMAT(T74,'*',T3,'*',2X,4(I12:))
	   WRITE(NUNIT,1)
	   DO 400 I=1,NROWPR
	      WRITE(NUNIT,8) I,(A(I,K),K=5*LIMIT+1,NCOLPR)
8             FORMAT(T74,'*',T3,'*',3X,I3,4(1PD12.3:))
400        CONTINUE
	END IF
	RETURN
C
C       LAST CARD OF SUBROUTINE MATPRT.
C
	END

