      PROGRAM MDR
C
C     MASTER DRIVER FOR MORE, GARBOW AND HILLSTROM PROBLEMS
C
C     AS GIVEN NOW NTEST RUNS FROM 1 TO 2 THUS TESTING ONLY NEWTON'S
C     BASIC PROGRAM.  IT CAN BE RUN FROM 1 TO 9 TO TEST DIFFERENT
C     ASPECTS.
C
C     PROGRAM RUNS QUICKLY EXCEPT FOR WATSON PROBLEM (#6 AND 7).
C
C     SUFFIX COMM ON OUTPUT FILES INDICATES FOR COMMUNICATION TO
C     COMPUTERS AND CHEM. ENG.
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      PARAMETER (  MGLL=     10,
     $     N=        40,
     $     NUNIT=    10)
      DOUBLE PRECISION
     $     JAC(N,N)  ,LAM0       ,MSTPF      ,NSTTOL
      INTEGER      ACPTCR    ,OUTPUT     ,QNUPDM     ,STOPCR   ,
     $     SUPPRS    ,TRMCOD     ,TRUPDM
      DIMENSION    A(N,N)    ,BOUNDL(N)  ,BOUNDU(N)  ,DELF(N)  ,
     $     FSAVE(N)  ,FTRACK(0:MGLL-1)       ,FVEC(N)  ,
     $     FVECC(N)  ,H(N,N)     ,HHPI(N)    ,PLEE(N,N),
     $     RDIAG(N)  ,S(N)       ,SBAR(N)    ,SCALEF(N),
     $     SCALEX(N) ,SN(N)      ,SSDHAT(N)  ,
     $     STRACK(0:MGLL-1)      ,VHAT(N)    ,WV1(N)   ,
     $     WV2(N)    ,WV3(N)     ,WV4(N)     ,XC(N)    ,
     $     XPLUS(N)  ,XSAVE(N)
      LOGICAL      ABSNEW    ,BYPASS     ,CAUCHY     ,DEUFLH   ,
     $     GEOMS     ,LINESR     ,MATSUP     ,NEWTON   ,
     $     OVERCH    ,WRNSUP
      CHARACTER*6  HELP
      CHARACTER*25 NAME
      DIMENSION NFE(6),ISUM(6)
      EXTERNAL FCN,JACOB
      COMMON/NNES_1/MATSUP
      COMMON/NNES_2/WRNSUP
      COMMON/NNES_3/BYPASS
      COMMON/NNES_4/NFETOT
      COMMON/PROBN/NPROB
      COMMON/H3R/R
      DO 10000 NTEST=2,2
         DO 10 I=1,6
            ISUM(I)=0
 10      CONTINUE
         IF(NTEST.EQ.1) THEN
            OPEN(UNIT=NUNIT,FILE='T1.OUT',STATUS='UNKNOWN')
         ELSEIF(NTEST.EQ.2) THEN
            OPEN(UNIT=NUNIT,FILE='T2.OUT',STATUS='UNKNOWN')
         ELSEIF(NTEST.EQ.3) THEN
            OPEN(UNIT=NUNIT,FILE='T3.OUT',STATUS='UNKNOWN')
         ELSEIF(NTEST.EQ.4) THEN
            OPEN(UNIT=NUNIT,FILE='T4.OUT',STATUS='UNKNOWN')
         ELSEIF(NTEST.EQ.5) THEN
            OPEN(UNIT=NUNIT,FILE='T5.OUT',STATUS='UNKNOWN')
         ELSEIF(NTEST.EQ.6) THEN
            OPEN(UNIT=NUNIT,FILE='T6.OUT',STATUS='UNKNOWN')
         ELSEIF(NTEST.EQ.7) THEN
            OPEN(UNIT=NUNIT,FILE='T7.OUT',STATUS='UNKNOWN')
         ELSEIF(NTEST.EQ.8) THEN
            OPEN(UNIT=NUNIT,FILE='T8.OUT',STATUS='UNKNOWN')
         ELSEIF(NTEST.EQ.9) THEN
            OPEN(UNIT=NUNIT,FILE='T9.OUT',STATUS='UNKNOWN')
         ELSEIF(NTEST.EQ.10) THEN
            OPEN(UNIT=NUNIT,FILE='T10.OUT',STATUS='UNKNOWN')
         END IF
         WRITE(NUNIT,1) NTEST
         PRINT 1, NTEST
 1       FORMAT(/T2,'NTEST: ',I3/)
         WRITE(NUNIT,2)
 2       FORMAT(/,T30,'NEWTON',10X,'BROYDEN',10X,'LEE AND LEE'/)
         WRITE(NUNIT,3)
 3       FORMAT(T29,'LS',4X,'TR',9X,'LS',4X,'TR',11X,'LS',4X,'TR'/)
         DO 20000 NPROB=20,20
            PRINT 4, NPROB
 4          FORMAT(T2,'NPROB: ',I3)
            ICOUNT=1
            DO 30000 NJUPD=0,0
               DO 40000 METHOD=1,1
                  IF(NPROB.EQ.1) THEN
C
C                    ROSENBROCK BANANA
C
                     NAME='Rosenbrock Banana'
                     NDIM=2
                     XC(1)=-1.2D0
                     XC(2)=1.0D0
                  ELSEIF(NPROB.EQ.2) THEN
C
C                    POWELL SINGULAR
C
                     NAME='Powell Singular '
                     NDIM=4
                     XC(1)=3.0D0
                     XC(2)=-1.0D0
                     XC(3)=0.0D0
                     XC(4)=1.0D0
C
                  ELSEIF(NPROB.EQ.3) THEN
C
C                    POWELL BADLY-SCALED
C
                     NAME='Powell Badly-Scaled'
                     NDIM=2
                     XC(1)=0.0D0
                     XC(2)=1.0D0
C
                  ELSEIF(NPROB.EQ.4) THEN
C
C                    WOOD
C
                     NAME='Wood '
                     NDIM=4
                     XC(1)=-3.0D0
                     XC(2)=-1.0D0
                     XC(3)=-3.0D0
                     XC(4)=-1.0D0
C
                  ELSEIF(NPROB.EQ.5) THEN
C
C                    HELICAL VALLEY
C
                     NAME='Helical Valley '
                     NDIM=3
                     XC(1)=-1.0D0
                     XC(2)=0.0D0
                     XC(3)=0.0D0
C
                  ELSEIF(NPROB.EQ.6.OR.NPROB.EQ.7) THEN
C
C                    WATSON
C
                     IF(NPROB.EQ.6) THEN
                        NAME='Watson 6-d'
                        NDIM=6
                     ELSE
                        NAME='Watson 9-d'
                        NDIM=9
                     END IF
                     DO 600 I=1,NDIM
                        XC(I)=0.0D0
 600                 CONTINUE
C
                  ELSEIF(NPROB.EQ.8.OR.NPROB.EQ.9.OR.NPROB.EQ.10) THEN
C
C                    CHEBYQUAD
C
                     IF(NPROB.EQ.8) THEN
                        NAME='Chebyquad 5-d '
                        NDIM=5
                     ELSEIF(NPROB.EQ.9) THEN
                        NAME='Chebyquad 6-d '
                        NDIM=6
                     ELSE
                        NAME='Chebyquad 7-d '
                        NDIM=7
                     END IF
                     DO 700 I=1,NDIM
                        XC(I)=DBLE(I)/(DBLE(NDIM)+1.0D0)
 700                 CONTINUE
C
                  ELSEIF(NPROB.EQ.11.OR.NPROB.EQ.12.OR.NPROB.EQ.13) THEN
C
C                    BROWN ALMOST-LINEAR
C
                     IF(NPROB.EQ.11) THEN
                        NAME='Brown Almost-Linear 10-d '
                        NDIM=10
                     ELSEIF(NPROB.EQ.12) THEN
                        NAME='Brown Almost-Linear 30-d '
                        NDIM=30
                     ELSE
                        NAME='Brown Almost-Linear 40-d '
                        NDIM=40
                     END IF
                     DO 800 I=1,NDIM
                        XC(I)=0.5D0
 800                 CONTINUE
C
                  ELSEIF(NPROB.EQ.14.OR.NPROB.EQ.15) THEN
C
C                    DISCRETE BOUNDARY VALUE
C                    DISCRETE INTEGRAL
C
                     if(NPROB.EQ.14) THEN
                        NAME='Discrete Boundary Value '
                     ELSE
                        NAME='Discrete Integral '
                     END IF
                     NDIM=10
                     HH=1.0D0/(DBLE(NDIM)+1.0D0)
                     DO 900 I=1,NDIM
                        TI=DBLE(I)*HH
                        XC(I)=TI*(TI-1.0D0)
 900                 CONTINUE
C
                  ELSEIF(NPROB.EQ.16) THEN
C
C                    TRIGONOMETRIC
C
                     NAME='Trigonometric '
                     NDIM=10
                     DO 1000 I=1,NDIM
                        XC(I)=0.1D0
 1000                CONTINUE
C
                  ELSEIF(NPROB.EQ.17) THEN
C
C                    VARIABLY DIMENSIONED
C
                     NAME='Variably Dimensioned '
                     NDIM=10
                     DO 1100 I=1,NDIM
                        XC(I)=1.0D0-0.1D0*DBLE(I)
 1100                CONTINUE
C
                  ELSEIF(NPROB.EQ.18.OR.NPROB.EQ.19) THEN
C
C                    BROYDEN TRIDIAGONAL
C                    BROYDEN BANDED
C
                     if(NPROB.EQ.18) THEN
                        NAME='Broyden Tridiagonal '
                     ELSE
                        NAME='Broyden Banded '
                     END IF
                     NDIM=10
                     DO 1200 I=1,NDIM
                        XC(I)=-1.0D0
 1200                CONTINUE
C
                  ELSEIF(NPROB.EQ.20.OR.NPROB.EQ.21) THEN
C
C                    HIEBERT #1
C
                     NAME='Hiebert #1 '
                     NDIM=2
                     IF(NPROB.EQ.20) THEN
                        XC(1)=0.0D0
                        XC(2)=0.0D0
                     ELSE
                        XC(1)=10.0D0
                        XC(2)=10.0D0
                     END IF
C
                  ELSEIF(NPROB.GE.22.AND.NPROB.LE.25) THEN
C
C                    HIEBERT #2
C
                     NAME='Hiebert #2 '
                     NDIM=6
                     IF(NPROB.NE.24) THEN
                        DO 1300 I=1,NDIM
                           IF(NPROB.EQ.22) XC(I)=0.0D0
                           IF(NPROB.EQ.23) XC(I)=1.0D0
                           IF(NPROB.EQ.25) XC(I)=10.0D0
 1300                   CONTINUE
                     ELSE
                        XC(1)=1.0D-04
                        XC(2)=1.0D-03
                        XC(3)=0.0D0
                        XC(4)=1.0D-04
                        XC(5)=55.0D0
                        XC(6)=1.0D-04
                     END IF
C
                  ELSEIF(NPROB.GE.26) THEN
C
C                    HIEBERT #3
C
                     NAME='Hiebert #3 '
                     NDIM=10
                     DO 1400 I=1,NDIM
                        XC(I)=0.0D0
 1400                CONTINUE
                     IF(NPROB.EQ.26) THEN
                        XC(1)=1.0D0
                        XC(2)=1.0D0
                        XC(3)=10.0D0
                        XC(4)=1.0D0
                        XC(5)=1.0D0
                        XC(6)=1.0D0
                        R=10.0D0
                     ELSEIF(NPROB.EQ.27) THEN
                        XC(1)=2.0D0
                        XC(2)=2.0D0
                        XC(3)=10.0D0
                        XC(4)=1.0D0
                        XC(5)=1.0D0
                        XC(6)=2.0D0
                        R=10.0D0
                     ELSEIF(NPROB.EQ.28) THEN
                        XC(1)=2.0D0
                        XC(2)=5.0D0
                        XC(3)=40.0D0
                        XC(4)=1.0D0
                        XC(10)=5.0D0
                        R=40.0D0
                     ELSE
                        XC(1)=1.0D0
                        XC(2)=1.0D0
                        XC(3)=20.0D0
                        XC(4)=1.0D0
                        XC(10)=1.0D0
                        R=40.0D0
                     END IF
                  END IF
                  CALL SETUP(ABSNEW ,CAUCHY ,DEUFLH ,GEOMS  ,LINESR ,
     $                 NEWTON ,OVERCH ,ACPTCR ,ITSCLF ,ITSCLX ,
     $                 JACTYP ,JUPDM  ,MAXEXP ,MAXIT  ,MAXNS  ,
     $                 MAXQNS ,MINQNS ,N      ,NARMIJ ,NIEJEV ,
     $                 NJACCH ,OUTPUT ,QNUPDM ,STOPCR ,SUPPRS ,
     $                 TRUPDM ,ALPHA  ,CONFAC ,DELTA  ,DELFAC ,
     $                 EPSMCH ,ETAFAC ,FDTOLJ ,FTOL   ,LAM0   ,
     $                 MSTPF  ,NSTTOL ,OMEGA  ,RATIOF ,SIGMA  ,
     $                 STPTOL ,BOUNDL ,BOUNDU ,SCALEF ,SCALEX ,
     $                 HELP)
C     BUG FIX 7 MAR 1998
                  JUPDM=NJUPD
                  OUTPUT=5
                  write(10,77) njupd,method
77                format('   njupd = ',i4,'   method = ',i4)
                  IF(NPROB.EQ.20) THEN
                     STOPCR=2
                  ELSEIF(NPROB.GE.22.AND.NPROB.LE.25) THEN
                     NSTTOL=1.0D-16
                     STPTOL=1.0D-16
                     BOUNDL(3)=0.0D0
                     BOUNDL(4)=0.0D0
                     BOUNDL(6)=0.0D0
                     BYPASS=.TRUE.
                  ELSEIF(NPROB.GE.26) THEN
                     BOUNDL(1)=0.0D0
                     BOUNDL(2)=0.0D0
                     BOUNDL(3)=0.0D0
                     BOUNDL(4)=0.0D0
                  END IF
                  IF(METHOD.EQ.1) THEN
                    linesr=.true.
                  else
                    linesr=.false.
                  END IF
                  if(ntest.eq.1) then
                     newton=.true.
                     GO TO 501
                  ELSEIF(NTEST.EQ.2) THEN
                     GO TO 501
                  ELSEIF(NTEST.EQ.3) THEN
                     ITSCLF=1
                     GO TO 501
                  ELSEIF(NTEST.EQ.4) THEN
                     ACPTCR=1
                     NARMIJ=MAXIT
                     DEUFLH=.FALSE.
                     GO TO 501
                  ELSEIF(NTEST.EQ.5) THEN
                     TRUPDM=1
                     DEUFLH=.FALSE.
                     GO TO 501
                  ELSEIF(NTEST.EQ.6) THEN
                     GEOMS=.FALSE.
                     GO TO 501
                  ELSEIF(NTEST.EQ.7) THEN
                     ACPTCR=1
                     GO TO 501
                  ELSEIF(NTEST.EQ.8) THEN
                     NARMIJ=MAXIT
                     GO TO 501
                  ELSEIF(NTEST.EQ.9) THEN
                     QNUPDM=0
                  ELSEIF(NTEST.EQ.10) THEN
                     NARMIJ=MAXIT
                     ACPTCR=1
                     GO TO 501
                  END IF
 501              CONTINUE
                  CALL NNES(ABSNEW ,CAUCHY ,DEUFLH ,GEOMS  ,LINESR ,
     $                 NEWTON ,OVERCH ,ACPTCR ,ITSCLF ,ITSCLX ,
     $                 JACTYP ,JUPDM  ,MAXEXP ,MAXIT  ,MAXNS  ,
     $                 MAXQNS ,MGLL   ,MINQNS ,NDIM   ,NARMIJ ,
     $                 NIEJEV ,NJACCH ,NJETOT ,NUNIT  ,OUTPUT ,
     $                 QNUPDM ,STOPCR ,SUPPRS ,TRMCOD ,TRUPDM ,
     $                 ALPHA  ,CONFAC ,DELTA  ,DELFAC ,EPSMCH ,
     $                 ETAFAC ,FCNNEW ,FDTOLJ ,FTOL   ,LAM0   ,
     $                 MSTPF  ,NSTTOL ,OMEGA  ,RATIOF ,SIGMA  ,
     $                 STPTOL ,A      ,BOUNDL ,BOUNDU ,DELF   ,
     $                 FSAVE  ,FTRACK ,FVEC   ,FVECC  ,H      ,
     $                 HHPI   ,JAC    ,PLEE   ,RDIAG  ,S      ,
     $                 SBAR   ,SCALEF ,SCALEX ,SN     ,SSDHAT ,
     $                 STRACK ,VHAT   ,WV1    ,WV2    ,WV3    ,
     $                 WV4    ,XC     ,XPLUS  ,XSAVE  ,HELP   ,
     $                 FCN    ,JACOB  )
                  NFE(ICOUNT)=NFETOT
                  IF(TRMCOD.GT.0) ISUM(ICOUNT)=ISUM(ICOUNT)+NFETOT
                  ICOUNT=ICOUNT+1
40000          CONTINUE
30000       CONTINUE
            PRINT 5, NAME,(NFE(I),I=1,6)
            WRITE(NUNIT,5) NAME,(NFE(I),I=1,6)
 5          FORMAT(T2,A,I4,3X,I3,8X,I3,3X,I3,10X,I3,3X,I3)
20000    CONTINUE
         WRITE(NUNIT,6)
 6       FORMAT(T28,'---',3X,'---',8X,'---',3X,'---',10X,'---',
     $        3X,'---')
         WRITE(NUNIT,7) (ISUM(I),I=1,6)
 7       FORMAT(T27,I4,2X,I4,7X,I4,2X,I4,9X,I4,2X,I4)
10000 CONTINUE
      STOP
      END
      SUBROUTINE FCN(OVERFL,N,FVEC,XC)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION FVEC(N),XC(N)
      COMMON/NNES_4/NFETOT
      COMMON/PROBN/NPROB
      DIMENSION T(0:9,9)
      DOUBLE PRECISION K1,K2,K3
      INTEGER R1,R2
      COMMON/H3R/R
      LOGICAL OVERFL
      OVERFL=.FALSE.
      NFETOT=NFETOT+1
      IF(NPROB.EQ.1) THEN
c
c        Rosenbrock Banana Function
c
         FVEC(1)=10.0D0*(XC(2)-XC(1)**2)
         FVEC(2)=1.0D0-XC(1)
      ELSEIF(NPROB.EQ.2) THEN
c
c        Powell Singular Function
c
         FVEC(1)=XC(1)+10.0D0*XC(2)
         FVEC(2)=SQRT(5.0D0)*(XC(3)-XC(4))
         FVEC(3)=(XC(2)-2.0D0*XC(3))**2
         FVEC(4)=SQRT(10.0D0)*(XC(1)-XC(4))**2
      ELSEIF(NPROB.EQ.3) THEN
c
c        Powell Badly-Scaled Function
c
         FVEC(1)=1.0D04*XC(1)*XC(2)-1.0D0
         FVEC(2)=EXP(-XC(1))+EXP(-XC(2))-1.0001D0
      ELSEIF(NPROB.EQ.4) THEN
c
c        Wood Function
c
c
         FVEC(1)=-200.0D0*XC(1)*(XC(2)-XC(1)**2)-(1.0D0-XC(1))
         FVEC(2)=100.0D0*(XC(2)-XC(1)**2)+10.0D0*(XC(2)+XC(4)-2.0D0)
     $        +0.1D0*(XC(2)-XC(4))
         FVEC(3)=-180.0D0*XC(3)*(XC(4)-XC(3)**2)-(1.0D0-XC(3))
         FVEC(4)=90.0D0*(XC(4)-XC(3)**2)+10.0D0*(XC(2)+XC(4)-2.0D0)
     $        -0.1D0*(XC(2)-XC(4))
      ELSEIF(NPROB.EQ.5) THEN
c
c        Helical Valley Function
c
         PI=3.14159265D0
         IF(XC(1).GT.0.0D0) THEN
            THETA=(1.0D0/(2.0D0*PI))*ATAN(XC(2)/XC(1))
         ELSE
            THETA=(1.0D0/(2.0D0*PI))*ATAN(XC(2)/XC(1))+0.5D0
         END IF
         FVEC(1)=10.0D0*(XC(3)-10.0D0*THETA)
         FVEC(2)=10.0D0*(SQRT((XC(1)**2+XC(2)**2))-1.0D0)
         FVEC(3)=XC(3)
      ELSEIF(NPROB.EQ.6.OR.NPROB.EQ.7) THEN
c
c        Watson Function
c
         DO 100 J=1,N
            FVEC(J)=0.0D0
            DO 200 I=1,29
               TI=DBLE(I)/29.0D0
               SUM=0.0D0
               DO 300 K=1,N
                  SUM=SUM+XC(K)*TI**(K-1)
 300           CONTINUE
               DFIDXJ=(DBLE(J)-1.0D0)*TI**(J-2)-2.0D0*SUM*TI**(J-1)
               SUM=0.0D0
               DO 400 K=2,N
                  SUM=SUM+(DBLE(K)-1.0D0)*XC(K)*TI**(K-2)
 400           CONTINUE
               SUM2=0.0D0
               DO 500 K=1,N
                  SUM2=SUM2+XC(K)*TI**(K-1)
 500           CONTINUE
               SUM2=SUM2**2+1.0D0
               FI=SUM-SUM2
               FVEC(J)=FVEC(J)+DFIDXJ*FI
 200        CONTINUE
 100     CONTINUE
         FVEC(1)=FVEC(1)+XC(1)-2.0D0*XC(1)*(XC(2)-XC(1)**2-1.0D0)
         FVEC(2)=FVEC(2)+XC(2)-XC(1)**2-1.0D0
      ELSEIF(NPROB.GE.8.AND.NPROB.LE.10) THEN
c
c        Chebyquad Function
c
         DO 600 K=1,N
            DO 700 J=1,N
               T(0,J)=1.0D0
               T(1,J)=2.0D0*XC(J)-1.0D0
               DO 800 I=2,N
                  T(I,J)=(4.0D0*XC(J)-2.0D0)*T(I-1,J)-T(I-2,J)
 800           CONTINUE
 700        CONTINUE
            FVEC(K)=0.0D0
            DO 900 I=1,N
               FVEC(K)=FVEC(K)+T(K,I)
 900        CONTINUE
            FVEC(K)=FVEC(K)/DBLE(N)
            IF(MOD(K,2).EQ.0) THEN
               FVEC(K)=FVEC(K)+1.0D0/(DBLE(K)**2-1.0D0)
            END IF
 600     CONTINUE
      ELSEIF(NPROB.GE.11.AND.NPROB.LE.13) THEN
c
c        Brown Almost-Linear Function
c
         SUM=0.0D0
         PROD=1.0D0
         DO 1000 J=1,N
            SUM=SUM+XC(J)
            PROD=PROD*XC(J)
 1000    CONTINUE
         SUM=SUM-(DBLE(N)+1.0D0)
         DO 1100 I=2,N
            FVEC(I)=XC(I)+SUM
 1100    CONTINUE
         FVEC(1)=PROD-1.0D0
      ELSEIF(NPROB.EQ.14) THEN
c
c        Discrete Boundary Value Function
c
         H=1.0D0/(DBLE(N)+1.0D0)
         DO 1200 I=2,N-1
            TI=DBLE(I)*H
            FVEC(I)=2.0D0*XC(I)-XC(I-1)-XC(I+1)+
     $           ((H**2)*(XC(I)+TI+1.0D0)**3)/2.0D0
 1200    CONTINUE
         T1=H
         FVEC(1)=2.0D0*XC(1)-XC(1+1)+
     $        ((H**2)*(XC(1)+T1+1.0D0)**3)/2.0D0
         TN=DBLE(N)*H
         FVEC(N)=2.0D0*XC(N)-XC(N-1)+
     $        ((H**2)*(XC(N)+TN+1.0D0)**3)/2.0D0
      ELSEIF(NPROB.EQ.15) THEN
c
c        Discrete Integral Equation
c
         H=1.0D0/(DBLE(N)+1.0D0)
         DO 1300 I=1,N
            TI=DBLE(I)*H
            SUM=0.0D0
            DO 1400 J=1,I
               TJ=DBLE(J)*H
               SUM=SUM+TJ*(XC(J)+TJ+1.0D0)**3
 1400       CONTINUE
            SUM=SUM*(1.0D0-TI)
            SUM2=0.0D0
            DO 1500 J=I+1,N
               TJ=DBLE(J)*H
               SUM2=SUM2+(1.0D0-TJ)*(XC(J)+TJ+1.0D0)**3
 1500       CONTINUE
            SUM2=SUM2*TI
            FVEC(I)=XC(I)+(H/2.0D0)*(SUM+SUM2)
 1300    CONTINUE
      ELSEIF(NPROB.EQ.16) THEN
c
c        Trigonometric Function
c
         DO 1600 I=1,N
            SUM=0.0D0
            DO 1700 J=1,N
               SUM=SUM+COS(XC(J))
 1700       CONTINUE
            FVEC(I)=DBLE(N)-SUM+DBLE(I)*(1.0D0-COS(XC(I)))
     $           -SIN(XC(I))
 1600    CONTINUE
      ELSEIF(NPROB.EQ.17) THEN
c
c        Variably Dimensioned Function
c
         SUM=0.0D0
         DO 1800 J=1,N
            SUM=SUM+DBLE(J)*(XC(J)-1.0D0)
 1800    CONTINUE
         DO 1900 I=1,N
            FVEC(I)=(XC(I)-1.0D0)+DBLE(I)*SUM+2.0D0
     $           *DBLE(I)*SUM**3
 1900    CONTINUE
      ELSEIF(NPROB.EQ.18) THEN
c
c        Broyden Tridiagonal Function
c
         DO 2000 I=2,N-1
            FVEC(I)=(3.0D0-2.0D0*XC(I))*XC(I)-XC(I-1)
     $           -2.0D0*XC(I+1)+1.0D0
 2000    CONTINUE
         FVEC(1)=(3.0D0-2.0D0*XC(1))*XC(1)        -2.0D0*XC(2)+1.0D0
         FVEC(N)=(3.0D0-2.0D0*XC(N))*XC(N)-XC(N-1)            +1.0D0
      ELSEIF(NPROB.EQ.19) THEN
c
c        Broyden Banded Function
c
         K1=2.0D0
         K2=5.0D0
         K3=1.0D0
         R1=5
         R2=1
c
         DO 2100 I=1,N
            SUM=0.0D0
            DO 2200 J=MAX(1,I-R1),MIN(N,I+R2)
               IF(J.NE.I) SUM=SUM+XC(J)*(1.0D0+XC(J))
 2200       CONTINUE
            FVEC(I)=(K1+K2*XC(I)**2)*XC(I)+1.0D0-K3*SUM
 2100    CONTINUE
      ELSEIF(NPROB.EQ.20.OR.NPROB.EQ.21) THEN
c
c        Hiebert's 1st Chemical Engineering Problem
c
         FVEC(1)=XC(2)-10.0D0
         FVEC(2)=XC(1)*XC(2)-5.0D04
      ELSEIF(NPROB.GE.22.AND.NPROB.LE.25) THEN
c
c        Hiebert's 2nd Chemical Engineering Problem
c
         FVEC(1)=XC(1)+XC(2)+XC(4)-0.001D0
         FVEC(2)=XC(5)+XC(6)-55.0D0
         FVEC(3)=XC(1)+XC(2)+XC(3)+2.0D0*XC(5)+XC(6)-110.001D0
         FVEC(4)=XC(1)-0.1D0*XC(2)
         FVEC(5)=XC(1)-1.0D04*XC(3)*XC(4)
         FVEC(6)=XC(5)-5.5D15*XC(3)*XC(6)
      ELSEIF(NPROB.GE.26) THEN
c
c        Hiebert's 3rd Chemical Reaction Problem (uncorrected)
c
         TOT=0.0D0
         DO 2300 I=1,N
            TOT=TOT+XC(I)
 2300    CONTINUE
         IF(TOT.LT.0.0D0) THEN
            OVERFL=.TRUE.
            RETURN
         END IF
         FVEC(1)=XC(1)+XC(4)-3.0D0
         FVEC(2)=2.0D0*XC(1)+XC(2)+XC(4)+XC(7)+XC(8)+XC(9)
     $        +2.0D0*XC(10)-R
         FVEC(3)=2.0D0*XC(2)+2.0D0*XC(5)+XC(6)+XC(7)-8.0D0
         FVEC(4)=2.0D0*XC(3)+XC(9)-4.0D0*R
         FVEC(5)=XC(1)*XC(5)-1.93D-01*XC(2)*XC(4)
         FVEC(6)=XC(6)*SQRT(XC(2))-2.597D-03*SQRT(XC(2)*XC(4)*TOT)
         FVEC(7)=XC(7)*SQRT(XC(4))-3.448D-03*SQRT(XC(1)*XC(2)*TOT)
         FVEC(8)=XC(8)*XC(4)-1.799D-05*XC(2)*TOT
         FVEC(9)=XC(9)*XC(4)-2.155D-04*XC(1)*SQRT(XC(3)*TOT)
         FVEC(10)=XC(10)*XC(4)**2-3.846D-05*XC(4)**2*TOT
      END IF
      RETURN
      END
      SUBROUTINE JACOB(OVERFL,N,JAC,XC)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DOUBLE PRECISION JAC(N,N)
      DIMENSION XC(N)
      LOGICAL OVERFL
      OVERFL=.FALSE.
********************************************************************
*     *
*     INSERT ANALYTICAL JACOBIAN IF DESIRED                      *
*     *
********************************************************************
      RETURN
      END
