	SUBROUTINE NESTOP(ABSNEW,LINESR,NEWTON,SCLFCH,SCLXCH,
     $                    ACPTCR,ITNUM ,N     ,NAC1  ,NAC2  ,
     $                    NAC12 ,NFUNC ,NJETOT,NUNIT ,OUTPUT,
     $                    STOPCR,TRMCOD,FCNNEW,FTOL  ,NSTTOL,
     $                    STPMAX,STPTOL,FVEC  ,SCALEF,SCALEX,
     $                    XC    ,XPLUS)
C
C       FEB. 23, 1992
C
C       THIS SUBROUTINE CHECKS TO SEE IF THE CONVERGENCE CRITERIA
C       HAVE BEEN MET.
C
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        DOUBLE PRECISION MAX1     ,MAX2      ,NSTTOL
        INTEGER          ACPTCR   ,OUTPUT    ,STOPCR    ,TRMCOD
        DIMENSION        FVEC(N)  ,SCALEF(N) ,SCALEX(N) ,XC(N)  ,
     $                   XPLUS(N)
	LOGICAL          ABSNEW   ,LINESR    ,NEWTON    ,SCLFCH ,
     $                   SCLXCH
        COMMON/NNES_4/NFETOT
	DATA ZERO,ONE,TWO /0.0D0,1.0D0,2.0D0/
C
        IF(OUTPUT.GT.3) THEN
           WRITE(NUNIT,1)
1          FORMAT(T3,'*',T74,'*')
           WRITE(NUNIT,2)
2          FORMAT(T3,'*',4X,'CONVERGENCE TESTING',T74,'*')
           WRITE(NUNIT,1)
        END IF
C
C       IF THE NEWTON STEP WAS WITHIN TOLERANCE THEN TRMCOD IS 1.
C
        IF(TRMCOD.EQ.1) THEN
           IF(OUTPUT.GT.3) THEN
	      WRITE(NUNIT,1)
	      IF(.NOT.SCLXCH) THEN
		 WRITE(NUNIT,3) STPMAX
3                FORMAT(T3,'*',6X,'MAXIMUM NEWTON STEP LENGTH',
     $           ' STPMAX:',1PD12.3,T74,'*')
	      ELSE
		 WRITE(NUNIT,4) STPMAX
4                FORMAT(T3,'*',6X,'MAXIMUM SCALED NEWTON STEP',
     $           ' LENGTH STPMAX:',1PD12.3,T74,'*')
	      END IF
	      WRITE(NUNIT,5) NSTTOL
5             FORMAT(T3,'*',6X,'FIRST CONVERGENCE CRITERION MET; ',
     $        ' NSTTOL IS:',1PD12.3,T74,'*')
              WRITE(NUNIT,1)
C
C             SKIP CHECKING OTHER STEP SIZE CRITERION AS TRMCOD IS
C             ALREADY 1.
C
              GO TO 101
           END IF
        END IF
C
C       IF THE NEWTON STEP WAS NOT WITHIN TOLERANCE THEN, IF
C       STOPCR IS NOT EQUAL TO 2, THE SECOND STEP SIZE STOPPING
C       CRITERION MUST BE CHECKED.
C
        IF(STOPCR.NE.2.AND.TRMCOD.NE.1) THEN
           MAX1=ZERO
           DO 100 I=1,N
              RATIO1=(ABS(XPLUS(I)-XC(I)))/MAX(ABS(XPLUS(I)),
     $               ONE/SCALEX(I))
              MAX1=MAX(MAX1,RATIO1)
              IF(OUTPUT.GT.4) THEN
		 WRITE(NUNIT,6) I,RATIO1
6                FORMAT(T3,'*',6X,'RELATIVE STEP SIZE (',I3,') = ',
     $           1PD12.3,T74,'*')
              END IF
100        CONTINUE
           IF(OUTPUT.GT.4) WRITE(NUNIT,1)
	   IF(OUTPUT.GT.3) THEN
	      IF(.NOT.SCLXCH) THEN
		 WRITE(NUNIT,7) MAX1,STPTOL
7                FORMAT(T3,'*',6X,'MAXIMUM STEP SIZE:',
     $           1PD12.3,3X,'STPTOL:',1PD11.3,T74,'*')
	      ELSE
		 WRITE(NUNIT,8) MAX1,STPTOL
8                FORMAT(T3,'*',6X,'MAXIMUM RELATIVE STEP SIZE:',
     $           1PD12.3,3X,'STPTOL:',1PD11.3,T74,'*')
	      END IF
	      WRITE(NUNIT,1)
           END IF
           IF(MAX1.LT.STPTOL) THEN
              TRMCOD=1
           END IF
        END IF
C
C       NOTE: CONTINUATION AT 101 MEANS THAT TRMCOD WAS 1 ON ENTRY
C             SO THE STEP SIZE CRITERION ABOVE DID NOT NEED TO BE
C             CHECKED.
C
101     CONTINUE
C
C       THE SECOND STOPPING CRITERION IS CHECKED IF NEEDED.
C
        IF(STOPCR.EQ.2.OR.STOPCR.EQ.12.OR.
     $      (STOPCR.EQ.3.AND.TRMCOD.EQ.1)) THEN
           MAX2=ZERO
           DO 200 I=1,N
              MAX2=MAX(MAX2,SCALEF(I)*ABS(FVEC(I)))
	      IF(OUTPUT.GT.4) THEN
		 IF(.NOT.SCLFCH) THEN
		    WRITE(NUNIT,9) I,ABS(FVEC(I))
9                   FORMAT(T3,'*',6X,'ABSOLUTE FUNCTION VECTOR (',I3,
     $              ') = ',1PD12.3,T74,'*')
		 ELSE
		    WRITE(NUNIT,10) I,SCALEF(I)*ABS(FVEC(I))
10                  FORMAT(T3,'*',6X,'ABSOLUTE SCALED FUNCTION',
     $              ' VECTOR (',I3,') = ',1PD12.3,T74,'*')
		 END IF
	      END IF
200        CONTINUE
           IF(OUTPUT.GT.4) WRITE(NUNIT,1)
	   IF(OUTPUT.GT.3) THEN
	      IF(.NOT.SCLFCH) THEN
		 WRITE(NUNIT,11) MAX2,FTOL
11               FORMAT(T3,'*',6X,'MAXIMUM ABSOLUTE FUNCTION:',
     $           1PD12.3,5X,'FTOL:',1PD11.3,T74,'*')
	      ELSE
		 WRITE(NUNIT,12) MAX2,FTOL
12               FORMAT(T3,'*',6X,'MAX ABSOLUTE SCALED',
     $           ' FUNCTION:',1PD12.3,5X,'FTOL:',1PD11.3,T74,'*')
	      END IF
	      WRITE(NUNIT,1)
           END IF
           IF(MAX2.LT.FTOL) THEN
              IF(STOPCR.EQ.3.AND.TRMCOD.EQ.1) THEN
C
C                BOTH NEEDED STOPPING CRITERIA HAVE BEEN MET.
C
                 TRMCOD=3
              ELSEIF(STOPCR.EQ.12.AND.TRMCOD.EQ.1) THEN
C
C                BOTH STOPPING CRITERIA HAVE BEEN MET ALTHOUGH
C                EITHER ONE WOULD BE SATISFACTORY.
C
                 TRMCOD=12
              ELSEIF(STOPCR.EQ.2.OR.STOPCR.EQ.12) THEN
                 TRMCOD=2
              END IF
           ELSEIF(STOPCR.EQ.3) THEN
C
C             ONLY THE FIRST STOPPING CRITERION WAS MET - TRMCOD
C             MUST BE RESET FROM 1 BACK TO 0.
C
              TRMCOD=0
           END IF
        END IF
C
C       PRINT FINAL RESULTS IF CONVERGENCE REACHED.
C
        IF(TRMCOD.GT.0) THEN
           IF(OUTPUT.GT.0) THEN
	      IF(OUTPUT.EQ.1) WRITE(NUNIT,13)
13            FORMAT(T3,72('*'))
	      WRITE(NUNIT,1)
	      WRITE(NUNIT,14) TRMCOD
14            FORMAT(T3,'*',6X,'CONVERGENCE REACHED;',
     $        ' TERMINATION CODE: ...............',I6,T74,'*')
C
C             ITERATION RESULTS NOT PRINTED IN NERSL.
C
	      WRITE(NUNIT,1)
	      WRITE(NUNIT,1)
	      IF(SCLFCH.OR.SCLXCH) THEN
		 WRITE(NUNIT,15)
15               FORMAT(T3,'*',29X,'UNSCALED RESULTS',T74,'*')
		 WRITE(NUNIT,1)
	     END IF
	     WRITE(NUNIT,16)
16            FORMAT(T3,'*',10X,'FINAL ESTIMATES',19X,'FINAL',
     $        ' FUNCTION VALUES',T74,'*')
              WRITE(NUNIT,1)
              DO 300 I=1,N
		 WRITE(NUNIT,17) I,XPLUS(I),I,FVEC(I)
17               FORMAT(T3,'*',6X,'X(',I3,') = ',1PD14.5,14X,
     $           'F(',I3,') = ',1PD14.5,T74,'*')
300           CONTINUE
	      WRITE(NUNIT,1)
	      IF(SCLFCH) THEN
C
C                NEED UNSCALED OBJECTIVE FUNCTION.
C
		 SUM=ZERO
		 DO 400 I=1,N
		    SUM=SUM+FVEC(I)*FVEC(I)
400              CONTINUE
		 WRITE(NUNIT,18) SUM/TWO
	      ELSE
		 WRITE(NUNIT,18) FCNNEW
	      END IF
18            FORMAT(T3,'*',6X,'FINAL OBJECTIVE FUNCTION VALUE:',
     $        1PD12.3,T74,'*')
	      IF(SCLFCH.OR.SCLXCH) THEN
		 WRITE(NUNIT,1)
		 WRITE(NUNIT,1)
		 WRITE(NUNIT,19)
19               FORMAT(T3,'*',30X,'SCALED RESULTS',T74,'*',/T3,'*',
     $           T74,'*',/T3,'*',10X,'FINAL ESTIMATES',19X,'FINAL',
     $           ' FUNCTION VALUES',T74,'*')
		 WRITE(NUNIT,1)
		 DO 500 I=1,N
		    WRITE(NUNIT,17) I,SCALEX(I)*XPLUS(I),
     $                              I,SCALEF(I)*FVEC(I)
500              CONTINUE
		 WRITE(NUNIT,1)
		 WRITE(NUNIT,18) FCNNEW
	      END IF
	   END IF
        ELSE
           IF(OUTPUT.GT.3) THEN
	      WRITE(NUNIT,20)
20            FORMAT(T3,'*',6X,'CONVERGENCE NOT REACHED',T74,'*')
              WRITE(NUNIT,1)
           END IF
           RETURN
        END IF
C
C       TERMINATION HAS BEEN REACHED.
C
        IF(OUTPUT.GT.0) THEN
	      WRITE(NUNIT,1)
	   WRITE(NUNIT,1)
	   WRITE(NUNIT,21) ITNUM
21         FORMAT(T3,'*',6X,'TOTAL NUMBER OF ITERATIONS',
     $     ': ..........................',I6,T74,'*')
	   IF(.NOT.NEWTON.AND.(.NOT.ABSNEW)) THEN
              IF(LINESR) THEN
		 WRITE(NUNIT,22) NFUNC
22               FORMAT(T3,'*',6X,'TOTAL NUMBER OF LINE SEARCH ',
     $           'FUNCTION EVALUATIONS: ....',I6,T74,'*')
              ELSE
		 WRITE(NUNIT,23) NFUNC
23               FORMAT(T3,'*',6X,'TOTAL NUMBER OF TRUST REGION',
     $           ' FUNCTION EVALUATIONS: ...',I6,T74,'*')
              END IF
           END IF
	   WRITE(NUNIT,24) NJETOT
24         FORMAT(T3,'*',6X,'TOTAL NUMBER OF EXPLICIT JACOBIAN',
     $     ' EVALUATIONS: .......',I6,T74,'*')
	   WRITE(NUNIT,25) NFETOT
25         FORMAT(T3,'*',6X,'TOTAL NUMBER OF FUNCTION',
     $     ' EVALUATIONS: ................',I6,T74,'*')
           WRITE(NUNIT,1)
	   IF(.NOT.NEWTON.AND.(.NOT.ABSNEW).AND.ACPTCR.NE.1.
     $        AND.OUTPUT.GT.2) THEN
	      WRITE(NUNIT,26) NAC1
26            FORMAT(T3,'*',6X,'NUMBER OF STEPS ACCEPTED',
     $        ' BY FUNCTION VALUE ONLY: .....',I6,T74,'*')
	      WRITE(NUNIT,27) NAC2
27            FORMAT(T3,'*',6X,'NUMBER OF STEPS ACCEPTED',
     $        ' BY STEP SIZE VALUE ONLY: ....',I6,T74,'*')
	      WRITE(NUNIT,28) NAC12
28            FORMAT(T3,'*',6X,'NUMBER OF STEPS ACCEPTED',
     $        ' BY EITHER CRITERION: ........',I6,T74,'*')
              WRITE(NUNIT,1)
           END IF
	   WRITE(NUNIT,13)
        END IF
        RETURN
C
C       LAST CARD OF SUBROUTINE NESTOP.
C
        END
