        SUBROUTINE NSTPFA(ABORT ,LINESR,OVERCH,OVERFL,QRSING,
     $                    RESTRT,SCLFCH,SCLXCH,ITNUM ,MAXEXP,
     $                    N     ,NEWSTM,NUNIT ,OUTPUT,EPSMCH,
     $                    A     ,DELF  ,FVECC ,H     ,HHPI  ,
     $                    JAC   ,RDIAG ,SCALEF,SCALEX,SN    ,
     $                    WV1   ,WV2   ,WV3)
C
C       FEB. 23, 1992
C
C       THIS SUBROUTINE FINDS THE NEWTON STEP.
C
C       IF THE JACOBIAN IS DETECTED AS SINGULAR OR IF THE ESTIMATED
C       CONDITION NUMBER IS TOO HIGH (GREATER THAN EPSMCH**(-2/3))
C       THEN H:=J^J IS FORMED AND THE DIAGONAL IS PERTURBED BY ADDING
C       SQRT(N*EPSMCH)*H1NORM*SCALEX(I)**2 TO THE CORRESPONDING
C       ELEMENT.  A CHOLESKY DECOMPOSITION IS PERFORMED ON THIS
C       MODIFIED MATRIX PRODUCING A PSEUDO-NEWTON STEP.
C
C       IF THE CONDITION NUMBER IS SMALL THEN THE NEWTON STEP, SN,
C       IS FOUND DIRECTLY BY BACK SUBSTITUTION.
C
C       ABORT    IF THE 1-NORM OF MATRIX H BECOMES TOO SMALL
C                ALTHOUGH BUT NOT AT A SOLUTION
C       BYPASS   ALLOWS BYPASSING OF THE SPECIAL TREATMENT FOR
C                BADLY CONDITIONED JACOBIANS
C       QRSING   INDICATES SINGULAR JACOBIAN DETECTED
C
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        DOUBLE PRECISION MAXADD   ,MAXFFL   ,JAC(N,N)
        INTEGER          OUTPUT
        DIMENSION        A(N,N)   ,DELF(N)  ,FVECC(N) ,H(N,N)   ,
     $                   HHPI(N)  ,RDIAG(N) ,SCALEF(N),SCALEX(N),
     $                   SN(N)    ,WV1(N)   ,WV2(N)   ,WV3(N)
	LOGICAL          ABORT    ,BYPASS   ,LINESR   ,MATSUP   ,
     $                   OVERCH   ,OVERFL   ,PERTRB   ,QRSING   ,
     $                   RESTRT   ,SCLFCH   ,SCLXCH   ,WRNSUP
	COMMON/NNES_1/MATSUP
        COMMON/NNES_2/WRNSUP
        COMMON/NNES_3/BYPASS
	DATA ZERO,ONE /0.0D0,1.0D0/
C
        ABORT=.FALSE.
        OVERFL=.FALSE.
        SQRTEP=SQRT(EPSMCH)
C
        IF(RESTRT) THEN
           IF(OUTPUT.GT.3) THEN
              WRITE(NUNIT,1)
1             FORMAT(T3,'*',T74,'*')
              WRITE(NUNIT,1)
              WRITE(NUNIT,2)
2             FORMAT(T3,'*',4X,'SOLUTION OF LINEAR SYSTEM FOR',
     $        ' NEWTON STEP, SN',T74,'*')
           END IF
C
C          STORE (POSSIBLY SCALED) JACOBIAN IN MATRIX A.
C
	   IF(.NOT.SCLFCH) THEN
	      CALL MATCOP(N,N,N,N,N,N,JAC,A)
	   ELSE
	      DO 100 I=1,N
		 IF(SCALEF(I).NE.ONE) THEN
		    SCALFI=SCALEF(I)
		    DO 200 J=1,N
		       A(I,J)=JAC(I,J)*SCALFI
200                 CONTINUE
		 ELSE
		    DO 300 J=1,N
		       A(I,J)=JAC(I,J)
300                 CONTINUE
		 END IF
100           CONTINUE
	   END IF
C
C          SCALED JACOBIAN IS PRINTED ONLY IF AT LEAST ONE SCALING
C          FACTOR IS NOT 1.0.
C
           IF(OUTPUT.GT.4.AND.SCLFCH) THEN
              WRITE(NUNIT,1)
              WRITE(NUNIT,1)
              WRITE(NUNIT,3)
3             FORMAT(T3,'*',7X,'SCALED JACOBIAN MATRIX',T74,'*')
              CALL MATPRT(N,N,N,N,NUNIT,A)
           END IF
C
C          QR DECOMPOSITION OF (POSSIBLY SCALED) JACOBIAN.
C
           CALL QRDCOM(QRSING,N,EPSMCH,A,HHPI,RDIAG)
C
	   IF(OUTPUT.GT.4.AND.N.GT.1.AND.(.NOT.MATSUP)) THEN
              WRITE(NUNIT,1)
	      IF(.NOT.SCLFCH) THEN
		 WRITE(NUNIT,4)
4                FORMAT(T3,'*',7X,'QR DECOMPOSITION OF JACOBIAN',
     $           ' MATRIX',T74,'*')
	      ELSE
		 WRITE(NUNIT,5)
5                FORMAT(T3,'*',7X,'QR DECOMPOSITION OF SCALED',
     $           ' JACOBIAN MATRIX',T74,'*')
	      END IF
              CALL MATPRT(N,N,N,N,NUNIT,A)
              WRITE(NUNIT,1)
	      WRITE(NUNIT,6)
6             FORMAT(T3,'*',12X,'DIAGONAL OF R',10X,'PI FACTORS',
     $        ' FROM QR DECOMPOSITION',T74,'*')
              WRITE(NUNIT,1)
	      DO 400 I=1,N-1
		 WRITE(NUNIT,7) I,RDIAG(I),I,HHPI(I)
7                FORMAT(T3,'*',7X,'RDIAG(',I3,') = ',1PD11.3,
     $           8X,'HHPI(',I3,') = ',1PD12.3,T74,'*')
400           CONTINUE
	      WRITE(NUNIT,8) N,RDIAG(N)
8             FORMAT(T3,'*',7X,'RDIAG(',I3,') = ',1PD11.3,
     $        T74,'*')
              WRITE(NUNIT,1)
              IF(ITNUM.EQ.1) THEN
		 WRITE(NUNIT,9)
9                FORMAT(T3,'*',7X,'NOTE: R IS IN STRICT UPPER',
     $           ' TRIANGLE OF MATRIX A PLUS RDIAG',T74,'*')
                 WRITE(NUNIT,1)
		 WRITE(NUNIT,10)
10                FORMAT(T3,'*',13X,'THE COLUMNS OF THE LOWER',
     $           ' TRIANGLE OF MATRIX A PLUS',T74,'*')
		 WRITE(NUNIT,11)
11               FORMAT(T3,'*',13X,'THE ELEMENTS OF VECTOR HHPI',
     $           ' FORM THE HOUSEHOLDER',T74,'*')
		 WRITE(NUNIT,12)
12               FORMAT(T3,'*',13X,'MATRICES WHICH, WHEN',
     $           ' MULTIPLIED TOGETHER, FORM Q',T74,'*')
              END IF
           END IF
C
C          FORM THE ACTUAL Q^ MATRIX FROM THE HOUSEHOLDER
C          TRANSFORMATIONS STORED IN THE LOWER TRIANGLE OF A
C          AND THE FACTORS IN HHPI: STORE IT IN JAC.
C
           CALL QFORM(N,A,HHPI,JAC)
C
C          COMPLETE THE UPPER TRIANGULAR R MATRIX BY REPLACING THE
C          DIAGONAL OF A.  THE QR DECOMPOSITION IS NOW AVAILABLE.
C
	   DO 500 I=1,N
              A(I,I)=RDIAG(I)
500        CONTINUE
C
        ELSE
C
C          USING UPDATED FACTORED FORM OF JACOBIAN - CHECK FOR
C          SINGULARITY.
C
           QRSING=.FALSE.
	   DO 600 I=1,N
              IF(A(I,I).EQ.ZERO) QRSING=.TRUE.
600        CONTINUE
C
        END IF
C
C       ESTIMATE CONDITION NUMBER IF JACOBIAN IS NOT SINGULAR.
C
	IF(.NOT.BYPASS.AND.(.NOT.QRSING).AND.N.GT.1) THEN
	   IF(SCLXCH) THEN
C
C             SET UP FOR CONDITION NUMBER ESTIMATION - SCALE R WRT X'S.
C
	      DO 700 J=1,N
		 IF(SCALEX(J).NE.ONE) THEN
		    SCALXJ=SCALEX(J)
		    RDIAG(J)=RDIAG(J)/SCALXJ
		    DO 800 I=1,J-1
		       A(I,J)=A(I,J)/SCALXJ
800                 CONTINUE
		 END IF
700           CONTINUE
	   END IF
C
	   CALL CONDNO(OVERCH,OVERFL,MAXEXP,N     ,NUNIT ,OUTPUT,
     $                 CONNUM,A     ,WV1   ,WV2   ,WV3   ,RDIAG )
C
C          UNSCALE R IF IT WAS SCALED BEFORE THE CALL TO CONDNO.
C
	   IF(SCLXCH) THEN
	      DO 900 J=1,N
		 IF(SCALEX(J).NE.ONE) THEN
		    SCALXJ=SCALEX(J)
		    RDIAG(J)=RDIAG(J)*SCALXJ
		    DO 1000 I=1,J-1
		       A(I,J)=A(I,J)*SCALXJ
1000                CONTINUE
		 END IF
900           CONTINUE
	   END IF
C
C          IF OVERFLOW DETECTED IN CONDITION NUMBER ESTIMATOR ASSIGN
C          QRSING AS TRUE SO THAT THE JACOBIAN WILL BE PERTURBED.
C
           IF(OVERFL) QRSING=.TRUE.
C
C          NOTE: OVERFL SWITCHED TO FALSE BEFORE FORMATION OF H.
C
        ELSE
           IF(N.EQ.1) THEN
              CONNUM=ONE
           ELSE
              CONNUM=ZERO
           END IF
	END IF
C
C       MATRIX H=JAC^JAC IS FORMED IN TWO CASES:
C          1)  THE (SCALED) JACOBIAN IS SINGULAR
C          2)  THE CONDITION NUMBER IS TOO HIGH AND THE
C              OPTION TO BYPASS THE PERTURBATION OF THE
C              JACOBIAN IS NOT BEING USED
C          3)  REQUESTED BY THE USER THROUGH NEWSTM.
C
        IF(QRSING.OR.((.NOT.BYPASS).AND.CONNUM.GT.
     $     ONE/SQRTEP**1.333).OR.NEWSTM.EQ.77) THEN
C
C          FORM H:=(DF*JAC)^(DF*JAC) WHERE DF=DIAG(SCALEF).  USE
C          PREVIOUSLY COMPUTED QR DECOMPOSITION OF (SCALED) JACOBIAN
C          WHERE R IS STORED IN THE UPPER TRIANGLE OF A AND RDIAG.
C
	   OVERFL=.FALSE.
	   IF(OVERCH) THEN
	      CALL ATAOV(OVERFL,MAXEXP,N,NUNIT,OUTPUT,JAC,H,SCALEF)
	   ELSE
	      CALL RTRMUL(N,A,H,RDIAG,WV1)
	   END IF
	   IF(OUTPUT.GT.3) THEN
              WRITE(NUNIT,1)
              IF(QRSING.AND.(.NOT.OVERFL)) THEN
		 WRITE(NUNIT,13)
13               FORMAT(T3,'*',7X,'SINGULAR JACOBIAN DETECTED:',
     $           ' JACOBIAN PERTURBED',T74,'*')
              ELSE
                 IF(OVERFL) THEN
		    WRITE(NUNIT,14)
14                  FORMAT(T3,'*',7X,'POTENTIAL OVERFLOW DETECTED',
     $              ' IN CONDITION NUMBER ESTIMATOR',T74,'*')
		    WRITE(NUNIT,15)
15                  FORMAT(T3,'*',7X,'MATRIX "ASSIGNED" AS ',
     $              'SINGULAR AND JACOBIAN PERTURBED',T74,'*')
                 ELSE
		    WRITE(NUNIT,16) CONNUM
16                  FORMAT(T3,'*',7X,'CONDITION NUMBER TOO HIGH: ',
     $              1PD12.3,', JACOBIAN PERTURBED',T74,'*')
                 END IF
              END IF
	   END IF
	   OVERFL=.FALSE.
	   IF(NEWSTM.NE.77) THEN
C
C             FIND 1-NORM OF H MATRIX AND PERTURB DIAGONAL.
C
	      CALL ONENRM(ABORT ,PERTRB,N     ,NUNIT ,OUTPUT,EPSMCH,
     $                    H1NORM,H     ,SCALEX)
	   END IF
C
C          CHOLESKY DECOMPOSITION OF H MATRIX - MAXFFL=0 INDICATES
C          THAT H IS KNOWNTO BE POSITIVE DEFINITE.
C
           MAXFFL=ZERO
           CALL CHOLDE(N,MAXADD,MAXFFL,SQRTEP,H,A)
           IF(OUTPUT.GT.4) THEN
              WRITE(NUNIT,1)
              WRITE(NUNIT,1)
	      WRITE(NUNIT,17)
17            FORMAT(T3,'*',5X,'CHOLESKY DECOMPOSITION OF H MATRIX',
     $        T74,'*')
              CALL MATPRT(N,N,N,N,NUNIT,A)
           END IF
C
C          FIND NEWTON STEP FROM CHOLESKY DECOMPOSITION.  IF THE
C          DIAGONAL HAS BEEN PERTURBED THEN THIS IS NOT THE ACTUAL
C          NEWTON STEP BUT ONLY AN APPROXIMATION THEREOF.
C
	   DO 1100 I=1,N
              WV1(I)=-DELF(I)
1100       CONTINUE
           CALL CHSOLV(OVERCH,OVERFL,MAXEXP,N     ,NUNIT ,
     $                 OUTPUT,A     ,WV1   ,SN    ,WV2)
	   OVERFL=.FALSE.
	   IF(OUTPUT.GT.3) THEN
	      IF(.NOT.SCLXCH) THEN
		 IF(.NOT.PERTRB) THEN
		    WRITE(NUNIT,18)
18                  FORMAT(T3,'*',5X,'NEWTON STEP FROM CHOLESKY',
     $              ' DECOMPOSITION',T74,'*')
		 ELSE
		    WRITE(NUNIT,19)
19                  FORMAT(T3,'*',5X,'APPROXIMATE NEWTON STEP FROM',
     $              ' PERTURBED JACOBIAN',T74,'*')
		 END IF
		 WRITE(NUNIT,1)
		 DO 1200 I=1,N
		    WRITE(NUNIT,20) I,SN(I)
20                  FORMAT(T3,'*',7X,'SN(',I3,') = ',1PD12.3,
     $              T74,'*')
1200             CONTINUE
	      ELSE
		 WRITE(NUNIT,1)
		 IF(.NOT.PERTRB) THEN
		    WRITE(NUNIT,21)
21                  FORMAT(T3,'*',5X,'NEWTON STEP FROM CHOLESKY',
     $              ' DECOMPOSITION',3X,' IN SCALED UNITS',T74,'*')
		 ELSE
		    WRITE(NUNIT,22)
22                  FORMAT(T3,'*',5X,'APPROXIMATE NEWTON STEP FROM',
     $              ' PERTURBED JACOBIAN',3X,'IN SCALED UNITS',T74,'*')
		 END IF
		 WRITE(NUNIT,1)
		 DO 1300 I=1,N
		    WRITE(NUNIT,23) I,SN(I),I,SCALEX(I)*SN(I)
23                  FORMAT(T3,'*',7X,'SN(',I3,') = ',1PD12.3,
     $              15X,'SN(',I3,') = ',1PD12.3,T74,'*')
1300             CONTINUE
	      END IF
	   END IF
C
C          SET QRSING TO TRUE SO THAT THE CORRECT MATRIX FACTORIZATION
C          IS USED IN THE BACK-CALCULATION OF SBAR FOR DEUFLHARD
C          RELAXATION FACTOR INITIALIZATION.
C
	   QRSING=.TRUE.
	ELSE
           IF(OUTPUT.GT.3.AND.N.GT.1) THEN
	      IF(.NOT.BYPASS.AND.CONNUM.LE.ONE/SQRTEP**1.33) THEN
                 WRITE(NUNIT,1)
		 WRITE(NUNIT,24) CONNUM
24               FORMAT(T3,'*',7X,'CONDITION NUMBER ACCEPTABLE, ',
     $           1PD9.2,', JACOBIAN NOT PERTURBED',T74,'*')
              END IF
              IF(BYPASS.AND.CONNUM.GT.ONE/SQRTEP**1.33) THEN
                 WRITE(NUNIT,1)
		 WRITE(NUNIT,25) CONNUM
25               FORMAT(T3,'*',7X,'CONDITION NUMBER HIGH, ',
     $           1PD9.2,', JACOBIAN NOT PERTURBED AS',T74,'*')
		 WRITE(NUNIT,26)
26               FORMAT(T3,'*',7X,'BYPASS IS TRUE',T74,'*')
              END IF
           END IF
	   DO 1400 I=1,N
	      SUM=ZERO
	      DO 1500 J=1,N
		 SUM=SUM-JAC(I,J)*SCALEF(J)*FVECC(J)
1500          CONTINUE
	      SN(I)=SUM
1400       CONTINUE
           CALL RSOLV(OVERCH,OVERFL,MAXEXP,N,NUNIT,OUTPUT,A,RDIAG,SN)
           OVERFL=.FALSE.
           IF(OUTPUT.GT.3) THEN
	      IF(.NOT.SCLXCH) THEN
		 WRITE(NUNIT,1)
		 WRITE(NUNIT,27)
27               FORMAT(T3,'*',7X,'NEWTON STEP FROM QR DECOMPOSITION '
     $           ,T74,'*')
		 WRITE(NUNIT,1)
		 DO 1600 I=1,N
		    WRITE(NUNIT,20) I,SN(I)
1600             CONTINUE
	      ELSE
		 WRITE(NUNIT,1)
		 WRITE(NUNIT,28)
28               FORMAT(T3,'*',7X,'NEWTON STEP FROM QR DECOMPOSITION '
     $           ,7X,'IN SCALED UNITS',T74,'*')
		 WRITE(NUNIT,1)
		 DO 1700 I=1,N
		    WRITE(NUNIT,23) I,SN(I),I,SCALEX(I)*SN(I)
1700             CONTINUE
	      END IF
           END IF
C
C          TRANSFORM MATRICES FOR SUBSEQUENT CALCULATIONS IN TRUST
C          REGION METHOD.
C
           IF(.NOT.LINESR) THEN
	      DO 1800 I=2,N
		 DO 1900 J=1,I-1
                    A(I,J)=A(J,I)
1900             CONTINUE
1800          CONTINUE
           END IF
        END IF
        RETURN
C
C       LAST CARD OF SUBROUTINE NSTPFA.
C
	END

