	SUBROUTINE NSTPUN(ABORT ,LINESR,OVERCH,OVERFL,QRSING,
     $                    SCLFCH,SCLXCH,ITNUM ,MAXEXP,N     ,
     $                    NUNIT ,OUTPUT,EPSMCH,A     ,DELF  ,
     $                    FVECC ,H     ,HHPI  ,JAC   ,RDIAG ,
     $                    SCALEF,SCALEX,SN    ,WV1   ,WV2   ,
     $                    WV3   )
C
C       FEB. 23, 1992
C
C       THIS SUBROUTINE FINDS THE NEWTON STEP.
C
C       IF THE JACOBIAN IS DETECTED AS SINGULAR OR IF THE ESTIMATED
C       CONDITION NUMBER IS TOO HIGH (GREATER THAN EPSMCH**(-2/3))
C       THEN H:=J^J IS FORMED AND THE DIAGONAL IS PERTURBED BY ADDING
C       SQRT(N*EPSMCH)*H1NORM*SCALEX(I)**2 TO THE CORRESPONDING
C       ELEMENT.  A CHOLESKY DECOMPOSITION IS PERFORMED ON THIS
C       MODIFIED MATRIX PRODUCING A PSEUDO-NEWTON STEP.
C       NOTE: THIS PROCEDURE MAY BE BE BYPASSED FOR ILL-CONDITIONED
C       JACOBIANS BY SETTING THE LOGICAL VARIABLE BYPASS TO TRUE
C       IN THE DRIVER.
C
C       ABORT    IF THE 1-NORM OF MATRIX H BECOMES TOO SMALL
C                ALTHOUGH BUT NOT AT A SOLUTION
C       BYPASS   ALLOWS BYPASSING OF THE SPECIAL TREATMENT FOR
C                BADLY CONDITIONED JACOBIANS
C       QRSING   INDICATES SINGULAR JACOBIAN DETECTED
C
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        DOUBLE PRECISION JAC(N,N) ,MAXADD   ,MAXFFL
        INTEGER          OUTPUT
        DIMENSION        A(N,N)   ,DELF(N)  ,FVECC(N)  ,H(N,N)   ,
     $                   HHPI(N)  ,RDIAG(N) ,SCALEF(N) ,SCALEX(N),
     $                   SN(N)    ,WV1(N)   ,WV2(N)    ,WV3(N)
	LOGICAL          ABORT    ,BYPASS   ,LINESR    ,MATSUP   ,
     $                   OVERCH   ,OVERFL   ,PERTRB    ,QRSING   ,
     $                   SCLFCH   ,SCLXCH   ,WRNSUP
	COMMON/NNES_1/MATSUP
	COMMON/NNES_2/WRNSUP
        COMMON/NNES_3/BYPASS
	COMMON/ILL/NEWSTM
	DATA ZERO,ONE /0.0D0,1.0D0/
C
        ABORT=.FALSE.
	OVERFL=.FALSE.
	PERTRB=.FALSE.
        SQRTEP=SQRT(EPSMCH)
C
        IF(OUTPUT.GT.3) THEN
           WRITE(NUNIT,1)
1          FORMAT(T3,'*',T74,'*')
           WRITE(NUNIT,1)
           WRITE(NUNIT,2)
2          FORMAT(T3,'*',4X,'SOLUTION OF LINEAR SYSTEM FOR',
     $     ' NEWTON STEP, SN',T74,'*')
	END IF
C
C       STORE (POSSIBLY SCALED) JACOBIAN IN MATRIX A.
C
	IF(.NOT.SCLFCH) THEN
	   CALL MATCOP(N,N,N,N,N,N,JAC,A)
	ELSE
	   DO 100 I=1,N
	      IF(SCALEF(I).NE.ONE) THEN
		 SCALFI=SCALEF(I)
		 DO 200 J=1,N
		    A(I,J)=JAC(I,J)*SCALFI
200              CONTINUE
	      ELSE
		 DO 300 J=1,N
		    A(I,J)=JAC(I,J)
300              CONTINUE
	      END IF
100        CONTINUE
	END IF
C
C       SCALED JACOBIAN IS PRINTED ONLY IF AT LEAST ONE SCALING
C       FACTOR IS NOT 1.0.
C
        IF(OUTPUT.GT.4.AND.SCLFCH) THEN
           WRITE(NUNIT,1)
           WRITE(NUNIT,1)
           WRITE(NUNIT,3)
3          FORMAT(T3,'*',7X,'SCALED JACOBIAN MATRIX',T74,'*')
           CALL MATPRT(N,N,N,N,NUNIT,A)
        END IF
C
C       QR DECOMPOSITION OF (POSSIBLY SCALED) JACOBIAN.
C
	CALL QRDCOM(QRSING,N,EPSMCH,A,HHPI,RDIAG)
C
C       SAVE MATRIX A FOR BACK SUBSTITUTION TO CHECK DEUFLHARDS'S
C       SECOND STEP ACCEPTANCE CRITERION IN LINE SEARCH OR TRUST
C       REGION METHOD.
C
	CALL MATCOP(N,N,N,N,N,N,A,H)
C
	IF(OUTPUT.GT.4.AND.N.GT.1.AND.(.NOT.MATSUP)) THEN
	   WRITE(NUNIT,1)
	   IF(.NOT.SCLFCH) THEN
	      WRITE(NUNIT,4)
4             FORMAT(T3,'*',7X,'QR DECOMPOSITION OF JACOBIAN',
     $        ' MATRIX',T74,'*')
	   ELSE
	      WRITE(NUNIT,5)
5             FORMAT(T3,'*',7X,'QR DECOMPOSITION OF SCALED JACOBIAN',
     $        ' MATRIX',T74,'*')
	   END IF
           CALL MATPRT(N,N,N,N,NUNIT,A)
	   WRITE(NUNIT,1)
	   WRITE(NUNIT,6)
6          FORMAT(T3,'*',12X,'DIAGONAL OF R',10X,'PI FACTORS',
     $     ' FROM QR DECOMPOSITION',T74,'*')
	   WRITE(NUNIT,1)
	   DO 400 I=1,N-1
	      WRITE(NUNIT,7) I,RDIAG(I),I,HHPI(I)
7             FORMAT(T3,'*',7X,'RDIAG(',I3,') = ',1PD11.3,
     $        8X,'HHPI(',I3,') = ',1PD12.3,T74,'*')
400        CONTINUE
	   WRITE(NUNIT,8) N,RDIAG(N)
8          FORMAT(T3,'*',7X,'RDIAG(',I3,') = ',1PD11.3,
     $     T74,'*')
	   WRITE(NUNIT,1)
	   IF(ITNUM.EQ.1) THEN
	      WRITE(NUNIT,9)
9             FORMAT(T3,'*',7X,'NOTE: R IS IN STRICT UPPER TRIANGLE',
     $        ' OF MATRIX A PLUS RDIAG',T74,'*')
	      WRITE(NUNIT,1)
	      WRITE(NUNIT,10)
10            FORMAT(T3,'*',13X,'THE COLUMNS OF THE LOWER TRIANGLE',
     $        ' OF MATRIX A PLUS',T74,'*',/T3,'*',13X,'THE ELEMENTS',
     $        ' OF VECTOR HHPI FORM THE HOUSEHOLDER',T74,'*')
	      WRITE(NUNIT,11)
11            FORMAT(T3,'*',13X,'MATRICES WHICH, WHEN MULTIPLIED',
     $        ' TOGETHER, FORM Q',T74,'*')
	   END IF
        END IF
C
C       ESTIMATE CONDITION NUMBER IF (SCALED) JACOBIAN IS NOT SINGULAR.
C
	IF(.NOT.BYPASS.AND.(.NOT.QRSING).AND.N.GT.1) THEN
	   IF(SCLXCH) THEN
C
C             SET UP FOR CONDITION NUMBER ESTIMATOR - SCALE R WRT X'S.
C
	      DO 500 J=1,N
		 IF(SCALEX(J).NE.ONE) THEN
		    SCALXJ=SCALEX(J)
		    RDIAG(J)=RDIAG(J)/SCALXJ
		    DO 600 I=1,J-1
		       A(I,J)=A(I,J)/SCALXJ
600                 CONTINUE
		 END IF
500           CONTINUE
	   END IF
C
	   CALL CONDNO(OVERCH,OVERFL,MAXEXP,N     ,NUNIT ,OUTPUT,
     $                 CONNUM,A     ,WV1   ,WV2   ,WV3   ,RDIAG )
C
C          IF OVERFLOW DETECTED IN CONDITION NUMBER ESTIMATOR ASSIGN
C          QRSING AS TRUE.
C
           IF(OVERFL) QRSING=.TRUE.
C
C          NOTE: OVERFL SWITCHED TO FALSE BEFORE FORMATION OF H LATER.
C
        ELSE
C
C          ASSIGN DUMMY TO CONNUM FOR SINGULAR JACOBIAN UNLESS N=1.
C
           IF(N.EQ.1) THEN
              CONNUM=ONE
           ELSE
              CONNUM=ZERO
           END IF
        END IF
C
C       MATRIX H=JAC^JAC IS FORMED IN THREE CASES:
C          1)  THE (SCALED) JACOBIAN IS SINGULAR
C          2)  THE CONDITION NUMBER IS TOO HIGH AND THE
C              OPTION TO BYPASS THE PERTURBATION OF THE
C              JACOBIAN IS NOT BEING USED.
C          3)  REQUESTED BY USER THROUGH NEWSTM.
C
        IF(QRSING.OR.((.NOT.BYPASS).AND.CONNUM.GT.
     $     ONE/SQRTEP**1.333).OR.NEWSTM.EQ.77) THEN
C
C          FORM H:=(DF*JAC)^(DF*JAC) WHERE DF=DIAG(SCALEF).  USE
C          PREVIOUSLY COMPUTED QR DECOMPOSITION OF (SCALED) JACOBIAN
C          WHERE R IS STORED IN THE UPPER TRIANGLE OF A AND RDIAG.
C
	   IF(OVERCH) THEN
	      OVERFL=.FALSE.
	      CALL ATAOV(OVERFL,MAXEXP,N,NUNIT,OUTPUT,JAC,H,SCALEF)
	   ELSE
	      CALL RTRMUL(N,A,H,RDIAG,WV1)
	   END IF
	   IF(OUTPUT.GT.3) THEN
              WRITE(NUNIT,1)
              IF(QRSING.AND.(.NOT.OVERFL)) THEN
                 WRITE(NUNIT,12)
12               FORMAT(T3,'*',7X,'SINGULAR JACOBIAN DETECTED:',
     $           ' JACOBIAN PERTURBED',T74,'*')
              ELSE
C
C                NOTE: IF OVERFL IS TRUE THEN QRSING MUST BE TRUE.
C
                 IF(OVERFL) THEN
                    WRITE(NUNIT,13)
13                  FORMAT(T3,'*',7X,'POTENTIAL OVERFLOW DETECTED',
     $              ' IN CONDITION NUMBER ESTIMATOR',T74,'*')
                    WRITE(NUNIT,14)
14                  FORMAT(T3,'*',7X,'MATRIX "ASSIGNED" AS ',
     $              'SINGULAR AND JACOBIAN PERTURBED',T74,'*')
                 ELSE
                    WRITE(NUNIT,15) CONNUM
15                  FORMAT(T3,'*',7X,'CONDITION NUMBER TOO HIGH: ',
     $              1PD12.3,', JACOBIAN PERTURBED',T74,'*')
                 END IF
              END IF
           END IF
	   OVERFL=.FALSE.
	   IF(NEWSTM.NE.77) THEN
C
C             FIND 1-NORM OF H MATRIX AND PERTURB DIAGONAL.
C
	      CALL ONENRM(ABORT ,PERTRB,N     ,NUNIT ,OUTPUT,EPSMCH,
     $                    H1NORM,H     ,SCALEX)
	      IF(ABORT) RETURN
	   END IF
C
C          CHOLESKY DECOMPOSITION OF H MATRIX - MAXFFL=0 IMPLIES
C          THAT H IS KNOWN TO BE POSITIVE DEFINITE.
C
           MAXFFL=ZERO
           CALL CHOLDE(N,MAXADD,MAXFFL,SQRTEP,H,A)
           IF(OUTPUT.GT.4) THEN
              WRITE(NUNIT,1)
              WRITE(NUNIT,1)
	      WRITE(NUNIT,16)
16            FORMAT(T3,'*',5X,'CHOLESKY DECOMPOSITION OF H MATRIX'
     $        ,T74,'*')
              CALL MATPRT(N,N,N,N,NUNIT,A)
           END IF
C
C          FIND NEWTON STEP FROM CHOLESKY DECOMPOSITION.  IF THE
C          DIAGONAL HAS BEEN PERTURBED THEN THIS IS NOT THE ACTUAL
C          NEWTON STEP BUT ONLY AN APPORXIMATION THEREOF.
C
	   DO 700 I=1,N
              WV1(I)=-DELF(I)
700        CONTINUE
           CALL CHSOLV(OVERCH,OVERFL,MAXEXP,N     ,NUNIT ,
     $                 OUTPUT,A     ,WV1   ,SN    ,WV2)
           OVERFL=.FALSE.
	   IF(OUTPUT.GT.3) THEN
	      IF(.NOT.SCLXCH) THEN
		 WRITE(NUNIT,1)
		 IF(.NOT.PERTRB) THEN
		    WRITE(NUNIT,17)
17                  FORMAT(T3,'*',5X,'NEWTON STEP FROM CHOLESKY',
     $              ' DECOMPOSITION',T74,'*')
		 ELSE
		    WRITE(NUNIT,18)
18                  FORMAT(T3,'*',5X,'APPROXIMATE NEWTON STEP FROM',
     $              ' PERTURBED JACOBIAN',T74,'*')
		 END IF
		 WRITE(NUNIT,1)
		 DO 800 I=1,N
		    WRITE(NUNIT,19) I,SN(I)
19                  FORMAT(T3,'*',7X,'SN(',I3,') = ',1PD12.3,
     $              T74,'*')
800              CONTINUE
	      ELSE
		 WRITE(NUNIT,1)
		 IF(.NOT.PERTRB) THEN
		    WRITE(NUNIT,20)
20                  FORMAT(T3,'*',5X,'NEWTON STEP FROM CHOLESKY',
     $              ' DECOMPOSITION',3X,' IN SCALED UNITS',T74,'*')
		 ELSE
		    WRITE(NUNIT,21)
21                  FORMAT(T3,'*',5X,'APPROXIMATE NEWTON STEP FROM',
     $              ' PERTURBED JACOBIAN',3X,'IN SCALED UNITS',T74,
     $              '*')
		 END IF
		 WRITE(NUNIT,1)
		 DO 900 I=1,N
		    WRITE(NUNIT,22) I,SN(I),I,SCALEX(I)*SN(I)
22                  FORMAT(T3,'*',7X,'SN(',I3,') = ',1PD12.3,
     $              15X,'SN(',I3,') = ',1PD12.3,T74,'*')
900              CONTINUE
	      END IF
	   END IF
C
C          SET QRSING TO TRUE SO THAT THE CORRECT MATRIX
C          FACTORIZATION IS USED IN THE BACK-CALCULATION OF
C          SBAR FOR DEUFLHARD RELAXATION FACTOR INITIALIZATION
C          IN LINE SEARCH (ONLY MATTERS WHEN JACOBIAN IS ILL-
C          CONDITIONED BUT NOT SINGULAR).
C
           QRSING=.TRUE.
        ELSE
	   IF(OUTPUT.GT.3.AND.N.GT.1) THEN
	      IF(.NOT.BYPASS.AND.CONNUM.LE.ONE/SQRTEP**1.33) THEN
                 WRITE(NUNIT,1)
		 WRITE(NUNIT,23) CONNUM
23               FORMAT(T3,'*',7X,'CONDITION NUMBER ACCEPTABLE, ',
     $           1PD9.2,', JACOBIAN NOT PERTURBED',T74,'*')
              END IF
              IF(BYPASS.AND.CONNUM.GT.ONE/SQRTEP**1.33) THEN
                 WRITE(NUNIT,1)
		 WRITE(NUNIT,24) CONNUM
24               FORMAT(T3,'*',7X,'CONDITION NUMBER HIGH, ',
     $           1PD9.2,', JACOBIAN NOT PERTURBED AS',T74,'*')
		 WRITE(NUNIT,25)
25               FORMAT(T3,'*',7X,'BYPASS IS TRUE',T74,'*')
              END IF
           END IF
C
C          NOTE: HERE SN STORES THE R.H.S. - IT IS OVERWRITTEN.
C
	   DO 1000 I=1,N
	      SN(I)=-FVECC(I)*SCALEF(I)
1000       CONTINUE
	   IF(.NOT.BYPASS.AND.SCLXCH) THEN
C
C             R WAS SCALED BEFORE THE CONDITION NUMBER ESTIMATOR -
C             THIS CONVERTS IT BACK TO THE UNSCALED FORM.
C
	      DO 1100 J=1,N
		 IF(SCALEX(J).NE.ONE) THEN
		    SCALXJ=SCALEX(J)
		    RDIAG(J)=RDIAG(J)*SCALXJ
		    DO 1200 I=1,J-1
		       A(I,J)=A(I,J)*SCALXJ
1200                CONTINUE
		 END IF
1100          CONTINUE
	   END IF
C
C          ACCEPTABLE CONDITION NUMBER - USE BACK SUBSTITUTION TO
C          FIND NEWTON STEP FROM QR DECOMPOSITION.
C
           CALL QRSOLV(OVERCH,OVERFL,MAXEXP,N     ,NUNIT ,
     $                 OUTPUT,A     ,HHPI  ,RDIAG ,SN    )
           OVERFL=.FALSE.
C
	   IF(OUTPUT.GT.3) THEN
	      IF(.NOT.SCLXCH) THEN
		 WRITE(NUNIT,1)
		 WRITE(NUNIT,26)
26               FORMAT(T3,'*',7X,'NEWTON STEP FROM QR DECOMPOSITION '
     $           ,T74,'*')
		 WRITE(NUNIT,1)
		 DO 1300 I=1,N
		    WRITE(NUNIT,19) I,SN(I)
1300             CONTINUE
	      ELSE
		 WRITE(NUNIT,1)
		 WRITE(NUNIT,27)
27               FORMAT(T3,'*',7X,'NEWTON STEP FROM QR DECOMPOSITION '
     $           ,7X,'IN SCALED UNITS',T74,'*')
		 WRITE(NUNIT,1)
		 DO 1400 I=1,N
		    WRITE(NUNIT,22) I,SN(I),I,SCALEX(I)*SN(I)
1400             CONTINUE
	      END IF
	   END IF
C
C          TRANSFORM MATRICES FOR SUBSEQUENT CALCULATIONS IN TRUST
C          REGION METHODS (A IS STORED ABOVE IN H).
C
           IF(.NOT.LINESR) THEN
	      DO 1500 I=1,N
                 A(I,I)=RDIAG(I)
		 DO 1600 J=1,I-1
                    A(I,J)=A(J,I)
1600             CONTINUE
1500          CONTINUE
           END IF
        END IF
        RETURN
C
C       LAST CARD OF SUBROUTINE NSTPUN.
C
        END
