        SUBROUTINE QRUPDA(OVERFL,MAXEXP,N,EPSMCH,A,JAC,U,V)
C
C       FEB. 12, 1991
C
C       UPDATE QR DECOMPOSITION USING A SERIES OF GIVENS ROTATIONS.
C
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        DOUBLE PRECISION JAC(N,N)
        DIMENSION        A(N,N)   ,HOLD(2)  ,U(N)   ,V(N)
        LOGICAL          OVERFL
        DATA ZERO /0.0D0/
C
C       REPLACE SUBDIAGONAL WITH ZEROS SO THAT WHEN R IS MULTIPLIED
C       BY GIVENS (JACOBI) ROTATIONS THE SUBDIAGONAL ELEMENTS DO
C       NOT AFFECT THE OUTCOME.
C
        DO 100 I=2,N
           A(I,I-1)=ZERO
100     CONTINUE
C
C       FIND LARGEST K FOR WHICH U(K) DOES NOT EQUAL ZERO.
C
        K=N
        DO 200 L=1,N
           IF(U(K).EQ.ZERO) THEN
              IF(K.GT.1) THEN
                 K=K-1
              ELSE
                 GO TO 201
              END IF
           ELSE
              GO TO 201
           END IF
200     CONTINUE
201     CONTINUE
C
C       MULTIPLY UV^ BY A SERIES OF ROTATIONS SO THAT ALL BUT THE
C       TOP ROW IS MADE ZERO (THEORETICALLY THIS IS WHAT HAPPENS
C       ALTHOUGH THIS MATRIX ISN'T ACTUALLY FORMED).
C
        DO 300 I=K-1,1,-1
           CALL JACROT(OVERFL,I,MAXEXP,N,U(I),U(I+1),EPSMCH,A,JAC)
           IF(U(I).EQ.ZERO) THEN
C
C             THIS STEP JUST AVOIDS ADDING ZERO.
C
              U(I)=ABS(U(I+1))
           ELSE
              HOLD(1)=U(I)
              HOLD(2)=U(I+1)
              LDHOLD=2
              CALL TWONRM(OVERFL,MAXEXP,LDHOLD,EPSMCH,EUCNRM,HOLD)
              U(I)=EUCNRM
           END IF
300     CONTINUE
C
C       ADD THE TOP ROW TO THE TOP ROW OF A - THIS FORMS THE
C       UPPER HESSENBERG MATRIX.
C
        DO 400 J=1,N
           A(1,J)=A(1,J)+U(1)*V(J)
400     CONTINUE
C
C       FORM THE UPPER TRIANGULAR R MATRIX BY A SERIES OF ROTATIONS
C       TO ZERO OUT THE SUBDIAGONALS.
C
        DO 500 I=1,K-1
           CALL JACROT(OVERFL,I     ,MAXEXP,N     ,A(I,I)  ,A(I+1,I),
     $                 EPSMCH,A     ,JAC)
500     CONTINUE
        RETURN
C
C       LAST CARD OF SUBROUTINE QRUPDA.
C
        END
