        SUBROUTINE RSOLV(OVERCH,OVERFL,MAXEXP,N     ,NUNIT ,
     $                   OUTPUT,A     ,RDIAG ,B     )
C
C       FEB. 14, 1991
C
C       THIS SUBROUTINE SOLVES, BY BACKWARDS SUBSTITUTION,
C
C              RX=B
C
C              WHERE    R IS TAKEN FROM THE QR DECOMPOSITION AND
C                         IS STORED IN THE STRICT UPPER TRIANGLE
C                         OF MATRIX A AND THE VECTOR, RDIAG
C                       B IS A GIVEN RIGHT HAND SIDE WHICH IS
C                         OVERWRITTEN
C
C       FRSTOV  INDICATES FIRST OVERFLOW - USED ONLY TO SET
C               BORDERS FOR OUTPUT
C
       IMPLICIT DOUBLE PRECISION (A-H,O-Z)
       DOUBLE PRECISION    MAXLOG
       INTEGER             OUTPUT
       DIMENSION           A(N,N) ,B(N)   ,RDIAG(N)
       LOGICAL             FRSTOV ,OVERCH ,OVERFL  ,WRNSUP
       COMMON/NNES_2/WRNSUP
       DATA ZERO,ONE,TEN /0.0D0,1.0D0,10.0D0/
C
       FRSTOV=.TRUE.
       OVERFL=.FALSE.
       EPS=TEN**(-MAXEXP)
C
       IF(OVERCH) THEN
          IF(LOG10(ABS(B(N))+EPS)-LOG10(ABS(RDIAG(N))+EPS)
     $       .GT.MAXEXP) THEN
             OVERFL=.TRUE.
             B(N)=SIGN(TEN**MAXEXP,B(N))*SIGN(ONE,RDIAG(N))
             IF(OUTPUT.GT.2.AND.(.NOT.WRNSUP)) THEN
                FRSTOV=.FALSE.
                WRITE(NUNIT,1)
1               FORMAT(T3,'*',T74,'*')
                WRITE(NUNIT,2) N,B(N)
2               FORMAT(T3,'*',4X,'WARNING: COMPONENT ',I3,
     $          ' SET TO ',1PD12.3,T74,'*')
             END IF
             GO TO 101
          END IF
       END IF
       B(N)=B(N)/RDIAG(N)
101    CONTINUE
       DO 200 I=N-1,1,-1
          IF(OVERCH) THEN
C
C            CHECK TO FIND IF ANY TERMS IN THE EVALUATION WOULD
C            OVERFLOW.
C
             MAXLOG=LOG10(ABS(B(I))+EPS)-LOG10(ABS(RDIAG(I))+EPS)
             JSTAR=0
             DO 300 J=I+1,N
                TMPLOG=LOG10(ABS(A(I,J))+EPS)+LOG10(ABS(B(J))+EPS)-
     $                  LOG10(ABS(RDIAG(I))+EPS)
                IF(TMPLOG.GT.MAXLOG) THEN
                   JSTAR=J
                   MAXLOG=TMPLOG
                END IF
300          CONTINUE
C
C            IF AN OVERFLOW WOULD OCCUR ASSIGN A VALUE FOR THE
C            TERM WITH CORRECT SIGN.
C
             IF(MAXLOG.GT.MAXEXP) THEN
                OVERFL=.TRUE.
                IF(JSTAR.EQ.0) THEN
                   B(I)=SIGN(TEN**MAXEXP,B(I))*
     $                  SIGN(ONE,RDIAG(I))
                ELSE
                   B(I)=-SIGN(TEN**MAXEXP,A(I,JSTAR))*
     $                   SIGN(ONE,B(JSTAR))*SIGN(ONE,RDIAG(I))
                END IF
                IF(FRSTOV) THEN
                   FRSTOV=.FALSE.
                   WRITE(NUNIT,1)
                END IF
                IF(OUTPUT.GT.2.AND.(.NOT.WRNSUP)) WRITE(NUNIT,2) I,B(I)
                GO TO 301
             END IF
          END IF
C
C         SUM FOR EACH TERM ORDERING OPERATIONS TO MINIMIZE
C         POSSIBILITY OF OVERFLOW.
C
          SUM=ZERO
          DO 400 J=I+1,N
             SUM=SUM+(MIN(ABS(A(I,J)),ABS(B(J)))/RDIAG(I))
     $           *(MAX(ABS(A(I,J)),ABS(B(J))))
     $           *SIGN(ONE,A(I,J))*SIGN(ONE,B(J))
400        CONTINUE
           B(I)=B(I)/RDIAG(I)-SUM
301     CONTINUE
200     CONTINUE
        RETURN
C
C       LAST CARD OF SUBROUTINE RSOLV.
C
        END
