	SUBROUTINE SETUP(ABSNEW ,CAUCHY ,DEUFLH ,GEOMS  ,LINESR ,
     $                   NEWTON ,OVERCH ,ACPTCR ,ITSCLF ,ITSCLX ,
     $                   JACTYP ,JUPDM  ,MAXEXP ,MAXIT  ,MAXNS  ,
     $                   MAXQNS ,MINQNS ,N      ,NARMIJ ,NIEJEV ,
     $                   NJACCH ,OUTPUT ,QNUPDM ,STOPCR ,SUPPRS ,
     $                   TRUPDM ,ALPHA  ,CONFAC ,DELTA  ,DELFAC ,
     $                   EPSMCH ,ETAFAC ,FDTOLJ ,FTOL   ,LAM0   ,
     $                   MSTPF  ,NSTTOL ,OMEGA  ,RATIOF ,SIGMA  ,
     $                   STPTOL ,BOUNDL ,BOUNDU ,SCALEF ,SCALEX ,
     $                   HELP)
C
C       DEC. 7, 1991
C
C       SUBROUTINE SETUP ASSIGNS DEFAULT VALUES TO ALL
C       REQUISITE PARAMETERS.
C
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        DOUBLE PRECISION  LAM0     ,MSTPF    ,NSTTOL
        INTEGER           ACPTCR   ,OUTPUT   ,QNUPDM   ,STOPCR   ,
     $                    SUPPRS   ,TRUPDM
        DIMENSION         BOUNDL(N),BOUNDU(N),SCALEF(N),SCALEX(N)
	LOGICAL           ABSNEW   ,BYPASS   ,CAUCHY   ,DEUFLH   ,
     $                    GEOMS    ,LINESR   ,MATSUP   ,NEWTON   ,
     $                    OVERCH   ,WRNSUP
	CHARACTER*6 HELP
        COMMON/NNES_1/MATSUP
        COMMON/NNES_2/WRNSUP
        COMMON/NNES_3/BYPASS
        COMMON/NNES_4/NFETOT
        COMMON/NNES_5/SMALLB,BIGB,SMALLS,BIGS,BIGR
	integer i1mach
	double precision d1mach
C
C       LOGICAL VALUES.
C
	ABSNEW=.FALSE.
        BYPASS=.FALSE.
        CAUCHY=.FALSE.
        DEUFLH=.TRUE.
        GEOMS=.TRUE.
        LINESR=.TRUE.
        MATSUP=.FALSE.
        NEWTON=.FALSE.
        OVERCH=.FALSE.
        WRNSUP=.FALSE.
C
C       INTEGER VALUES.
C
        ACPTCR=12
        ITSCLF=0
        ITSCLX=0
        JACTYP=1
        JUPDM=0
        MAXIT=250
        MAXNS=50
        MAXQNS=10
        MINQNS=7
        NARMIJ=1
        NFETOT=0
	NIEJEV=1
        NJACCH=1
        OUTPUT=2
        QNUPDM=1
        STOPCR=12
        SUPPRS=0
        TRUPDM=0
C
C       REAL VALUES.
C
        ALPHA   = 1.0D-04
        CONFAC  = 0.95D0
        DELTA   =-1.0D0
        DELFAC  = 2.0D0
        ETAFAC  = 0.2D0
        LAM0    = 1.0D0
        MSTPF   = 1.0D3
        OMEGA   = 0.1D0
        RATIOF  = 0.70D0
	SIGMA   = 0.5D0
C
C       CHARACTER VARIABLE.
C
	HELP(1:4)='NONE'
C
C       NOTE: NOTATIONAL CHANGES IN CALLING PROGRAM FROM MACHAR
C             1)  EPSMCH DENOTES MACHINE EPSILON
C             2)  MINEBB DENOTES MINIMUM EXPONENT BASE BETA
C             3)  MAXEBB DENOTES MAXIMUM EXPONENT BASE BETA
C
*       CALL MACHAR(IBETA ,IT    ,IRND  ,NGRD  ,MACHEP,
*    $              NEGEP ,IEXP  ,MINEBB,MAXEBB,EPSMCH,
*    $              EPSNEG,XMIN  ,XMAX  )
	IT = i1mach(14)
	IBETA = i1mach(10)
	MINEBB = i1mach(15)
	MAXEBB = i1mach(16)
	EPSMCH = d1mach(4)
	XMAX = d1mach(2)
        MAXEXP=INT(DBLE(MAXEBB)*LOG(DBLE(IBETA))/LOG(10.0D0))
C
C       VALUES FOR TWO-NORM CALCULATIONS.
C
        SMALLB=DBLE(IBETA)**((MINEBB+1)/2)
        BIGB=  DBLE(IBETA)**((MAXEBB-IT+1)/2)
        SMALLS=DBLE(IBETA)**((MINEBB-1)/2)
        BIGS=  DBLE(IBETA)**((MAXEBB+IT-1)/2)
        BIGR=  XMAX
C
C       SET STOPPING CRITERIA PARAMETERS.
C
        FDTOLJ  = 1.0D-06
        FTOL    = EPSMCH**0.333
        NSTTOL  = FTOL*FTOL
        STPTOL  = NSTTOL
C
C       VECTOR VALUES.
C
	TEMP=-10.0D0**MAXEXP
        DO 100 I=1,N
           BOUNDL(I)=TEMP
	   BOUNDU(I)=-TEMP
           SCALEF(I)=1.0D0
           SCALEX(I)=1.0D0
100     CONTINUE
        RETURN
C
C       LAST CARD OF SUBROUTINE SETUP.
C
	END

