        SUBROUTINE TRSTUP(GEOMS ,NEWTKN,OVERCH,OVERFL,QRSING,
     $                    SCLFCH,SCLXCH,ACPCOD,ACPSTR,ACPTCR,
     $                    CONTYP,ISEJAC,JUPDM ,MAXEXP,MGLL  ,
     $                    MNEW  ,N     ,NARMIJ,NFUNC ,NOTRST,
     $                    NUNIT ,OUTPUT,QNUPDM,RETCOD,TRUPDM,
     $                    ALPHA ,CONFAC,DELFAC,DELSTR,DELTA ,
     $                    EPSMCH,FCNMAX,FCNNEW,FCNOLD,FCNPRE,
     $                    MAXSTP,NEWLEN,NEWMAX,POWTAU,RELLEN,
     $                    STPTOL,A     ,ASTORE,BOUNDL,BOUNDU,
     $                    DELF  ,FPLPRE,FTRACK,FVEC  ,FVECC ,
     $                    HHPI  ,JAC   ,RDIAG ,RHS   ,S     ,
     $                    SBAR  ,SCALEF,SCALEX,STRACK,WV3   ,
     $                    XC    ,XPLPRE,XPLUS ,FVECEV)
C
C       FEB. 28, 1992
C
C       THIS SUBROUTINE CHECKS FOR ACCEPTANCE OF A TRUST REGION
C       STEP GENERATED BY THE DOUBLE DOGLEG METHOD.
C
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
	DOUBLE PRECISION   JAC(N,N)  ,MAXSTP     ,NEWLEN   ,NEWMAX
        INTEGER            ACPCOD    ,ACPSTR     ,ACPTCR   ,CONTYP   ,
     $                     OUTPUT    ,QNUPDM     ,RETCOD   ,TRUPDM
        DIMENSION          A(N,N)    ,ASTORE(N,N),BOUNDL(N),BOUNDU(N),
     $                     DELF(N)   ,FTRACK(0:MGLL-1)     ,FPLPRE(N),
     $                     FVEC(N)   ,FVECC(N)   ,HHPI(N)  ,RDIAG(N) ,
     $                     RHS(N)    ,S(N)       ,SBAR(N)  ,SCALEF(N),
     $                     SCALEX(N) ,STRACK(0:MGLL-1)     ,WV3(N)   ,
     $                     XC(N)     ,XPLPRE(N)  ,XPLUS(N)
        LOGICAL            CONVIO    ,GEOMS      ,NEWTKN   ,OVERCH   ,
     $                     OVERFL    ,QRSING     ,SCLFCH   ,SCLXCH   ,
     $                     WRNSUP
        COMMON/NNES_2/WRNSUP
        EXTERNAL FVECEV
	DATA ZERO,PT5,THREEQ,ONE,ONEPT1,TWO,TEN
     $  /0.0D0,0.5D0,0.75D0,1.0D0,1.1D0,2.0D0,10.0D0/
C
C       NOTE: ACCEPTANCE CODE, ACPCOD, IS 0 ON ENTRANCE TO TRSTUP
C
        CONVIO=.FALSE.
        OVERFL=.FALSE.
C
        IF(OUTPUT.GT.3) THEN
           WRITE(NUNIT,1)
1          FORMAT(T3,'*',T74,'*')
	   WRITE(NUNIT,1)
	   IF(.NOT.SCLFCH.AND.(.NOT.SCLXCH)) THEN
	      WRITE(NUNIT,2)
2             FORMAT(T3,'*',4X,'TRUST REGION UPDATING',T74,'*')
	   ELSE
	      WRITE(NUNIT,3)
3             FORMAT(T3,'*',4X,'TRUST REGION UPDATING (ALL X''','S',
     $        ' AND F''','S IN UNSCALED UNITS)',T74,'*')
	   END IF
	   WRITE(NUNIT,1)
        END IF
C
C       CHECK TO MAKE SURE "S" IS A DESCENT DIRECTION - FIND
C       DIRECTIONAL DERIVATIVE AT CURRENT XC USING S GENERATED
C       BY DOGLEG SUBROUTINE.
C
	CALL INNERP(OVERCH,OVERFL,MAXEXP,N     ,N     ,N     ,NUNIT ,
     $              OUTPUT,DELFTS,DELF  ,S     )
        IF(OUTPUT.GT.3) THEN
           WRITE(NUNIT,1)
	   WRITE(NUNIT,4) DELFTS
4          FORMAT(T3,'*',7X,'INNER PRODUCT OF DELF AND S, DELFTS: '
     $     ,'........',1PD13.4,T74,'*')
        END IF
	IF(DELFTS.GT.ZERO) THEN
           IF(OUTPUT.GT.3) THEN
              WRITE(NUNIT,1)
	      WRITE(NUNIT,5)
5             FORMAT(T3,'*',7X,'DIRECTIONAL DERIVATIVE POSITIVE',
     $        '; SEARCH DIRECTION REVERSED',T74,'*')
           END IF
           DO 100 I=1,N
              S(I)=-S(I)
100        CONTINUE
        END IF
C
C       FIND MAXIMUM OBJECTIVE FUNCTION VALUE AND MAXIMIUM STEP
C       LENGTH FOR NONMONOTONIC SEARCH.  THIS HAS TO BE DONE ONLY
C       ONCE DURING EACH ITERATION (WHERE NOTRST=1).
C
        IF(NOTRST.EQ.1) THEN
           NEWMAX=NEWLEN
           FCNMAX=FCNOLD
           IF(ISEJAC.GT.NARMIJ) THEN
              IF(ISEJAC.LT.NARMIJ+MGLL) THEN
                 DO 200 J=1,MNEW
                    FCNMAX=MAX(FCNMAX,FTRACK(J-1))
                    NEWMAX=MAX(NEWMAX,STRACK(J-1))
200              CONTINUE
              ELSE
                 DO 300 J=0,MNEW
                    FCNMAX=MAX(FCNMAX,FTRACK(J))
                    NEWMAX=MAX(NEWMAX,STRACK(J))
300              CONTINUE
              END IF
           END IF
        END IF
C
C       TEST TRIAL POINT - FIND XPLUS AND TEST FOR CONSTRAINT
C       VIOLATIONS IF CONTYP DOES NOT EQUAL 0.
C
        DO 400 I=1,N
	   WV3(I)=-ONE
C
C          WV3 IS A MARKER FOR "VIOLATORS" - IT CHANGES TO 1 OR 2.
C
           XPLUS(I)=XC(I)+S(I)
           IF(CONTYP.GT.0) THEN
              IF(XPLUS(I).LT.BOUNDL(I)) THEN
                 CONVIO=.TRUE.
		 WV3(I)=ONE
              ELSEIF(XPLUS(I).GT.BOUNDU(I)) THEN
                 CONVIO=.TRUE.
		 WV3(I)=TWO
              END IF
           END IF
400     CONTINUE
C
C       IF CONSTRAINT IS VIOLATED ...
C
        IF(CONVIO) THEN
           IF(OUTPUT.GT.3) THEN
              WRITE(NUNIT,1)
	      WRITE(NUNIT,6)
6             FORMAT(T3,'*',7X,'CONSTRAINT VIOLATED',T74,'*',/T3,'*',
     $        T74,'*',/T3,'*',10X,'TRIAL ESTIMATES (VIOLATIONS MARKED)'
     $        ,T74,'*')
              WRITE(NUNIT,1)
              DO 500 I=1,N
		 IF(WV3(I).GT.ZERO) THEN
                    WRITE(NUNIT,7) I,XPLUS(I)
7                   FORMAT(T3,'*',13X,'XPLUS(',I3,') = ',1PD12.3,
     $              2X,'*',T74,'*')
                 ELSE
                    WRITE(NUNIT,8) I,XPLUS(I)
8                   FORMAT(T3,'*',13X,'XPLUS(',I3,') = ',1PD12.3,
     $              T74,'*')
                 END IF
500           CONTINUE
           END IF
C
C          FIND STEP WITHIN CONSTRAINED REGION.
C
C          FIND THE RATIO OF THE DISTANCE FROM THE (I)TH
C          COMPONENT TO ITS CONSTRAINT TO THE LENGTH OF THE
C          PROPOSED STEP, XPLUS(I)-XC(I).  MULTIPLY THIS BY
C          CONFAC (DEFAULT 0.95) TO ENSURE THE NEW STEP STAYS
C          WITHIN THE ACCEPTABLE REGION UNLESS XC IS CLOSE TO
C          THE BOUNDARY (RATIO <= 1/2).  IN SUCH CASES A FACTOR
C          OF 0.5*CONFAC IS USED.
C
C          NOTE: ONLY THE VIOLATING COMPONENTS ARE REDUCED.
C
	   RATIOM=ONE
C
C          RATIOM STORES THE MINIMUM VALUE OF RATIO.
C
           DO 600 I=1,N
	      IF(WV3(I).EQ.ONE) THEN
                 RATIO=(BOUNDL(I)-XC(I))/S(I)
	      ELSEIF(WV3(I).EQ.TWO) THEN
                 RATIO=(BOUNDU(I)-XC(I))/S(I)
              END IF
	      IF(WV3(I).GT.ZERO) THEN
C
C                NOTE: RATIO IS STORED IN WV3 FOR OUTPUT ONLY.
C
                 WV3(I)=RATIO
C
                 RATIOM=MIN(RATIOM,RATIO)
		 IF(RATIO.GT.PT5) THEN
                    XPLUS(I)=XC(I)+CONFAC*RATIO*S(I)
                 ELSE
C
C                   WITHIN BUFFER ZONE.
C
		    XPLUS(I)=XC(I)+CONFAC*RATIO*S(I)/TWO
                 END IF
                 S(I)=XPLUS(I)-XC(I)
              END IF
600        CONTINUE
           IF(OUTPUT.GT.3) THEN
              WRITE(NUNIT,1)
              WRITE(NUNIT,1)
              WRITE(NUNIT,9)
9             FORMAT(T3,'*',7X,'NEW S AND XPLUS VECTORS',
     $        ' (WITH RATIOS FOR VIOLATIONS)',T74,'*')
              WRITE(NUNIT,1)
              WRITE(NUNIT,10)
10            FORMAT(T3,'*',7X,'NOTE: RATIOS ARE RATIO OF',
     $        ' LENGTH TO BOUNDARY FROM CURRENT',T74,'*')
              WRITE(NUNIT,11)
11            FORMAT(T3,'*',7X,'X VECTOR TO MAGNITUDE OF',
     $        ' CORRESPONDING PROPOSED STEP',T74,'*')
              WRITE(NUNIT,1)
              DO 700 I=1,N
		 IF(WV3(I).LT.ZERO) THEN
                    WRITE(NUNIT,12) I,S(I),I,XPLUS(I)
12                  FORMAT(T3,'*',7X,'S(',I3,') = ',1PD12.3,4X,
     $              'XPLUS(',I3,') = ',1PD12.3,T74,'*')
                 ELSE
                    WRITE(NUNIT,13) I,S(I),I,XPLUS(I),WV3(I)
13                  FORMAT(T3,'*',7X,'S(',I3,') = ',1PD12.3,4X,
     $              'XPLUS(',I3,') = ',1PD12.3,1X,1PD11.3,T74,'*')
                 END IF
700           CONTINUE
              WRITE(NUNIT,1)
              WRITE(NUNIT,14) RATIOM
14            FORMAT(T3,'*',7X,'MINIMUM OF RATIOS, RATIOM: ',
     $        1PD12.3,T74,'*')
           END IF
C
C          THE NEW POINT, XPLUS, IS NOT NECESSARILY IN A DESCENT
C          DIRECTION.  CHECK DIRECTIONAL DERIVATIVE FOR MODIFIED
C          STEP, DLFTSM.
C
	   CALL INNERP(OVERCH,OVERFL,MAXEXP,N     ,N     ,N     ,
     $                 NUNIT ,OUTPUT,DLFTSM,DELF  ,S     )
           IF(OUTPUT.GT.3) THEN
              WRITE(NUNIT,1)
              WRITE(NUNIT,15) DLFTSM
15            FORMAT(T3,'*',7X,'INNER PRODUCT OF DELF AND MODIFIED S',
     $        ', DLFTSM: ',1PD12.3,T74,'*')
           END IF
C
C          IF DLFTSM IS POSITIVE REDUCE TRUST REGION.  IF NOT, TEST
C          NEW POINT.
C
	   IF(DLFTSM.GT.ZERO) THEN
              DELTA=CONFAC*RATIOM*DELTA
              RETCOD=8
              RETURN
           END IF
        END IF
C
C       CONSTRAINTS NOT (OR NO LONGER) VIOLATED - TEST NEW POINT.
C
        CALL FVECEV(OVERFL,N,FVEC,XPLUS)
        NFUNC=NFUNC+1
C
C       IF OVERFLOW AT NEW POINT REDUCE TRUST REGION AND RETURN.
C
        IF(OVERFL) THEN
C
C          IF THE OVERFLOW COMES AS A RESULT OF INCREASING DELTA
C          WITHIN THE CURRENT ITERATION (IMPLYING DELSTR IS POSITIVE)
C          AND DIVIDING DELTA BY 10 WOULD PRODUCE A DELTA WHICH
C          IS SMALLER THAN THAT AT THE STORED POINT, THEN USE
C          STORED POINT AS THE UPDATED RESULT.
C
	   IF(DELSTR.GT.DELTA/TEN) THEN
	      CALL MATCOP(N,N,1,1,N,1,XPLPRE,XPLUS)
	      CALL MATCOP(N,N,1,1,N,1,FPLPRE,FVEC)
              ACPCOD=ACPSTR
              DELTA=DELSTR
              FCNNEW=FCNPRE
              RETCOD=1
           ELSE
	      DELTA=DELTA/TEN
              RETCOD=9
           END IF
           RETURN
        END IF
C
C       NO OVERFLOW IN RESIDUAL VECTOR.
C
        IF(OUTPUT.GT.3) THEN
           WRITE(NUNIT,1)
           WRITE(NUNIT,16)
16         FORMAT(T3,'*',12X,'TRIAL ESTIMATES',18X,
     $     'FUNCTION VALUES',T74,'*')
           WRITE(NUNIT,1)
           DO 800 I=1,N
              WRITE(NUNIT,17) I,XPLUS(I),I,FVEC(I)
17            FORMAT(T3,'*',7X,'XPLUS(',I3,') = ',1PD12.3,9X,
     $        'FVEC(',I3,') = ',1PD12.3,T74,'*')
800        CONTINUE
        END IF
C
C       IF NO OVERFLOW WITHIN RESIDUAL VECTOR FIND OBJECTIVE
C       FUNCTION.
C
        CALL FCNEVL(OVERFL,MAXEXP,N     ,NUNIT ,OUTPUT,
     $              EPSMCH,FCNNEW,FVEC  ,SCALEF,WV3   )
C
C       IF OVERFLOW IN OBJECTIVE FUNCTION EVALUATION REDUCE
C       TRUST REGION AND RETURN.
C
        IF(OVERFL) THEN
C
C          IF THE OVERFLOW COMES AS A RESULT OF INCREASING DELTA
C          WITHIN THE CURRENT ITERATION (SO THAT DELSTR IS POSITIVE)
C          AND DIVIDING DELTA BY 10 WOULD PRODUCE A DELTA WHICH
C          IS SMALLER THAN THAT AT THE STORED POINT THEN USE
C          STORED POINT AS THE UPDATED RESULT.
C
	   IF(DELSTR.GT.DELTA/TEN) THEN
	      CALL MATCOP(N,N,1,1,N,1,XPLPRE,XPLUS)
	      CALL MATCOP(N,N,1,1,N,1,FPLPRE,FVEC)
              ACPCOD=ACPSTR
              DELTA=DELSTR
              FCNNEW=FCNPRE
              RETCOD=2
           ELSE
	      DELTA=DELTA/TEN
              RETCOD=10
           END IF
           RETURN
        ELSE
C
C          NO OVERFLOW AT TRIAL POINT - COMPARE OBJECTIVE FUNCTION
C          TO FCNMAX.
C
           IF(OUTPUT.GT.3) THEN
	      WRITE(NUNIT,1)
	      IF(.NOT.SCLFCH) THEN
		 WRITE(NUNIT,18) FCNNEW
18               FORMAT(T3,'*',7X,'OBJECTIVE FUNCTION AT XPLUS,',
     $           ' FCNNEW: .........',1PD12.4,T74,'*')
	      ELSE
		 WRITE(NUNIT,19) FCNNEW
19               FORMAT(T3,'*',7X,'SCALED OBJECTIVE FUNCTION AT XPLUS',
     $           ', FCNNEW: ..',1PD12.4,T74,'*')
	      END IF
	      WRITE(NUNIT,20) FCNMAX+ALPHA*DELFTS
20            FORMAT(T3,'*',7X,'COMPARE TO FCNMAX+ALPHA*DELFTS: ',
     $        14('.'),1PD12.4,T74,'*')
           END IF
        END IF
C
C       IF ACPTCR=12 CHECK SECOND DEUFLHARD STEP ACCEPTANCE TEST
C       BY FINDING 2-NORM OF SBAR.  THERE ARE FOUR POSSIBILITIES
C       DEPENDING ON WHETHER THE JACOBIAN IS OR IS NOT SINGULAR
C       AND WHETHER QNUPDM IS 0 OR 1.
C
        IF(ACPTCR.EQ.12) THEN
           IF(QRSING) THEN
C
C             FORM -J^F AS RIGHT HAND SIDE - METHOD DEPENDS ON
C             WHETHER QNUPDM EQUALS 0 OR 1 (UNFACTORED OR FACTORED).
C
              IF(QNUPDM.EQ.0) THEN
C
C                UNSCALED JACOBIAN IS IN MATRIX JAC.
C
                 DO 900 I=1,N
		    WV3(I)=-FVEC(I)*SCALEF(I)*SCALEF(I)
900              CONTINUE
		 CALL ATBMUL(N,N,1,1,N,N,JAC,WV3,RHS)
C
	      ELSE
C
C                R IN UPPER TRIANGLE OF A PLUS RDIAG AND Q^ IN JAC
C                FROM QR DECOMPOSITION OF SCALED JACOBIAN.
C
                 DO 1000 I=1,N
		    SUM=ZERO
                    DO 1100 J=1,N
                       SUM=SUM-JAC(I,J)*FVEC(J)*SCALEF(J)
1100                CONTINUE
		    WV3(I)=SUM
1000             CONTINUE
                 RHS(1)=RDIAG(1)*WV3(1)
                 DO 1200 J=2,N
		    SUM=ZERO
                    DO 1300 I=1,J-1
                       SUM=SUM+A(I,J)*WV3(I)
1300                CONTINUE
                    RHS(J)=SUM+RDIAG(J)*WV3(J)
1200             CONTINUE
              END IF
              CALL CHSOLV(OVERCH,OVERFL,MAXEXP,N     ,NUNIT ,
     $                    OUTPUT,A     ,RHS   ,SBAR  ,WV3   )
	   ELSE
C
C             RIGHT HAND SIDE IS -FVEC.
C
              IF(QNUPDM.EQ.0.OR.JUPDM.EQ.0) THEN
C
C                QR DECOMPOSITION OF SCALED JACOBIAN STORED IN
C                ASTORE.
C
                 DO 1400 I=1,N
                    SBAR(I)=-FVEC(I)*SCALEF(I)
1400             CONTINUE
                 CALL QRSOLV(OVERCH,OVERFL,MAXEXP,N     ,NUNIT ,
     $                       OUTPUT,ASTORE,HHPI  ,RDIAG ,SBAR  )
              ELSE
C
C                SET UP RIGHT HAND SIDE - MULTIPLY -FVEC BY Q^
C                (STORED IN JAC).  RHS IS A WORK VECTOR ONLY HERE.
C
                 DO 1500 I=1,N
                    WV3(I)=-FVEC(I)*SCALEF(I)
1500             CONTINUE
		 CALL AVMUL(N,N,N,N,JAC,WV3,SBAR)
		 CALL RSOLV(OVERCH,OVERFL,MAXEXP,N     ,NUNIT ,
     $                      OUTPUT,A     ,RDIAG ,SBAR  )
              END IF
           END IF
C
C          NORM OF (SCALED) SBAR IS NEEDED FOR SECOND ACCEPTANCE TEST.
C
	   DO 1600 I=1,N
	      WV3(I)=SCALEX(I)*SBAR(I)
1600       CONTINUE
	   CALL TWONRM(OVERFL,MAXEXP,N,EPSMCH,SBRNRM,WV3)
C
           IF(OUTPUT.GT.4) THEN
	      WRITE(NUNIT,1)
	      IF(.NOT.SCLXCH) THEN
		 WRITE(NUNIT,21)
21               FORMAT(T3,'*',10X,'DEUFLHARD SBAR VECTOR',T74,'*')
		 WRITE(NUNIT,1)
		 DO 1700 I=1,N
		    WRITE(NUNIT,22) I,SBAR(I)
22                  FORMAT(T3,'*',10X,'SBAR(',I3,') = ',
     $              1PD12.3,T74,'*')
1700             CONTINUE
	      ELSE
		 WRITE(NUNIT,23)
23               FORMAT(T3,'*',10X,'DEUFLHARD SBAR VECTOR',14X,
     $           'IN SCALED X UNITS',T74,'*')
		 WRITE(NUNIT,1)
		 DO 1800 I=1,N
		    WRITE(NUNIT,24) I,SBAR(I),I,SCALEX(I)*SBAR(I)
24                  FORMAT(T3,'*',10X,'SBAR(',I3,') = ',1PD12.3,
     $              8X,'SBAR(',I3,') = ',1PD12.3,T74,'*')
1800             CONTINUE
	      END IF
	   END IF
           IF(OUTPUT.GT.3) THEN
	      WRITE(NUNIT,1)
	      IF(.NOT.SCLXCH) THEN
		 WRITE(NUNIT,25) SBRNRM
25               FORMAT(T3,'*',10X,'VALUE OF SBRNRM',
     $           ' AT XPLUS: .................'1PD12.4,T74,'*')
	      ELSE
		 WRITE(NUNIT,26) SBRNRM
26               FORMAT(T3,'*',10X,'VALUE OF SCALED SBRNRM',
     $           ' AT XPLUS: ..........'1PD12.4,T74,'*')
	      END IF
	      WRITE(NUNIT,27) NEWMAX
27            FORMAT(T3,'*',10X,'NEWMAX: ',35('.'),1PD12.4,T74,'*')
           END IF
           IF(SBRNRM.LT.NEWMAX) ACPCOD=2
C
C          FUNCTION VALUE ACCEPTANCE IS ALSO CHECKED REGARDLESS
C          OF WHETHER SECOND STEP ACCEPTANCE CRITERION WAS MET.
C
        END IF
C
C       ESTABLISH DELTAF FOR USE IN COMPARISON TO PREDICTED
C       CHANGE IN OBJECTIVE FUNCTION, DELFPR, LATER.
C
        DELTAF=FCNNEW-FCNOLD
        IF(FCNNEW.GE.FCNMAX+ALPHA*DELFTS) THEN
C
C          FAILURE OF FIRST STEP ACCEPTANCE TEST. TEST LENGTH OF
C          STEP TO ENSURE PROGRESS IS STILL BEING MADE.
C
	   RELLEN=ZERO
	   DO 1900 I=1,N
              RELLEN=MAX(RELLEN,ABS(S(I))/
     $               MAX((ABS(XPLUS(I))),ONE/SCALEX(I)))
1900       CONTINUE
           IF(RELLEN.LT.STPTOL) THEN
C
C             NO PROGRESS BEING MADE - RETCOD = 7 STOPS PROGRAM.
C
	      CALL MATCOP(N,N,1,1,N,1,XC,XPLUS)
              RETCOD=7
              RETURN
           ELSE
C
C             FAILURE OF STEP BY OBJECTIVE FUNCTION CRITERION.
C             ESTABLISH A NEW DELTA FROM EITHER SIMPLE DIVISION
C             BY DELFAC OR BY FINDING THE MINIMUM OF A QUADRATIC
C             MODEL.
C
              IF(GEOMS) THEN
                 DELTA=DELTA/DELFAC
              ELSE
C
C                FIRST FIND LENGTH OF TRUST REGION STEP.
C
                 DO 2000 I=1,N
                    WV3(I)=S(I)*SCALEX(I)
2000             CONTINUE
		 CALL TWONRM(OVERFL,MAXEXP,N,EPSMCH,STPLEN,WV3)
C
                 CALL QMIN(NUNIT,OUTPUT,DELFTS,DELTA,DELTAF,STPLEN)
C
              END IF
              IF(DELTA.LT.DELSTR) THEN
C
C                IF DELTA HAS BEEN INCREASED AT THIS ITERATION
C                AND THE DELTA FROM QMIN IS LESS THAN THE DELTA
C                AT THE PREVIOUSLY ACCEPTED (STORED) POINT THEN
C                RETURN TO THAT POINT AND ACCEPT IT AS THE UPDATED
C                ITERATE.
C
		 CALL MATCOP(N,N,1,1,N,1,XPLPRE,XPLUS)
		 CALL MATCOP(N,N,1,1,N,1,FPLPRE,FVEC)
                 ACPCOD=ACPSTR
                 DELTA=DELSTR
                 FCNNEW=FCNPRE
                 RETCOD=3
                 RETURN
              END IF
C
C             IF THE SECOND ACCEPTANCE TEST HAS BEEN PASSED RETURN
C             WITH NEW TRUST REGION AND CONTINUE ON TO NEXT ITER-
C             ATION; OTHERWISE TRY A NEW STEP WITH REDUCED DELTA.
C
              IF(ACPCOD.EQ.2) THEN
                 RETCOD=4
              ELSE
C
C                FAILURE OF FIRST STEP ACCEPTANCE TEST.
C
                 RETCOD=11
              END IF
              RETURN
           END IF
        ELSE
C
C          OBJECTIVE FUNCTION MEETS FIRST ACCEPTANCE CRITERION.
C          IN NONMONOTONIC SEARCHES IT MAY BE GREATER THAN THE
C          PREVIOUS OBJECTIVE FUNCTION VALUE - CONSIDER THIS
C          CASE FIRST.
C
           IF(DELTAF.GE.ALPHA*DELFTS) THEN
C
C             AN ACCEPTABLE STEP HAS BEEN FOUND FOR THE
C             NONMONOTONIC SEARCH BUT THE OBJECTIVE FUNCTION
C             VALUE IS NOT A "DECREASE" FROM THE PREVIOUS
C             ITERATION (ACTUALLY IT MIGHT BE BETWEEN ZERO AND
C             ALPHA*DELFTS).  ACCEPT STEP BUT REDUCE DELTA.
C
              DELTA=DELTA/DELFAC
              RETCOD=5
              IF(ACPCOD.EQ.2) THEN
                 ACPCOD=12
              ELSE
                 ACPCOD=1
              END IF
              RETURN
           END IF
C
C          COMPARE DELTAF TO DELTAF PREDICTED, DELFPR, TO DETERMINE
C          NEXT TRUST REGION SIZE.  NOTE: DELTAF MUST BE LESS THAN
C          ALPHA*DELFTS (IN ESSENCE NEGATIVE) TO HAVE REACHED THIS
C          POINT IN TRSTUP.  R IS IN UPPER TRIANGLE OF MATRIX A SO
C          THE FOLLOWING CODE FINDS:
C
C          DELFPR = DELF^S + 1/2 S^J^JS = DELF^S + 1/2 S^R^RS
C
	   DELFPR=DELFTS
	   CALL UVMUL(N,N,N,N,A,S,WV3)
	   DO 2100 I=1,N
	      DELFPR=DELFPR+WV3(I)*WV3(I)/TWO
2100       CONTINUE
           IF(OUTPUT.GT.4) THEN
              WRITE(NUNIT,1)
	      WRITE(NUNIT,28) DELFPR
28            FORMAT(T3,'*',7X,'PREDICTED CHANGE IN OBJECTIVE',
     $        ' FUNCTION, DELFPR:',1PD12.3,T74,'*')
	      WRITE(NUNIT,29) DELTAF
29            FORMAT(T3,'*',7X,'   ACTUAL CHANGE IN OBJECTIVE',
     $        ' FUNCTION, DELTAF:',1PD12.3,T74,'*')
           END IF
	   IF(RETCOD.LE.6.AND.(ABS(DELFPR-DELTAF).LE.
     $     ABS(DELTAF)/TEN.OR.DELTAF.LE.DELFTS).AND.(.NOT.NEWTKN)
     $     .AND.(.NOT.CONVIO).AND.DELSTR.EQ.ZERO) THEN
	      IF(MIN(NEWLEN,MAXSTP)/DELTA.GT.ONEPT1) THEN
C
C                PROMISING STEP - INCREASE TRUST REGION.
C
C                STORE CURRENT POINT.
C
		 CALL MATCOP(N,N,1,1,N,1,XPLUS,XPLPRE)
		 CALL MATCOP(N,N,1,1,N,1,FVEC,FPLPRE)
                 DELSTR=DELTA
                 FCNPRE=FCNNEW
C
C                IF NONMONOTONIC STEPS ARE BEING USED EXPAND TRUST
C                REGION TO NEWLEN, OTHERWISE EXPAND BY DELFAC.
C
                 IF(ISEJAC.GT.NARMIJ) THEN
                    DELTA=MIN(NEWLEN,MAXSTP)
                 ELSE
                    DELTA=MIN(DELFAC*DELTA,MAXSTP)
                 END IF
                 RETCOD=12
                 IF(ACPCOD.EQ.2) THEN
                    ACPSTR=12
                 ELSE
                    ACPSTR=1
                 END IF
                 ACPCOD=0
              ELSE
                 RETCOD=0
                 IF(ACPCOD.EQ.2) THEN
                    ACPCOD=12
                 ELSE
                    ACPCOD=1
                 END IF
              END IF
              RETURN
           ELSE
C
C             CHANGE TRUST REGION SIZE DEPENDING ON DELTAF AND
C             DELFPR.
C
              RETCOD=6
              IF(ACPCOD.EQ.2) THEN
                 ACPCOD=12
              ELSE
                 ACPCOD=1
              END IF
	      IF(DELTAF.GE.DELFPR/TEN) THEN
                 DELTA=DELTA/DELFAC
                 IF(OUTPUT.GT.3) THEN
                    WRITE(NUNIT,1)
		    WRITE(NUNIT,30)
30                  FORMAT(T3,'*',7X,'CHANGE IN F, DELTAF, IS GREATER',
     $              ' THAN .1 DELFPR - REDUCE DELTA',T74,'*')
                 END IF
              ELSEIF(TRUPDM.EQ.0.AND.JUPDM.GT.0) THEN
C
C                POWELL'S UPDATING SCHEME - FIND JAC S FIRST.
C
                 IF(QNUPDM.EQ.0) THEN
C
C                   UNSCALED JACOBIAN IN JAC.
C
                    DO 2200 I=1,N
                       RHS(I)=S(I)*SCALEF(I)
2200                CONTINUE
		    CALL AVMUL(N,N,N,N,JAC,RHS,WV3)
                 ELSE
C
C                   MULTIPLY BY R FIRST.
C
		    CALL UVMUL(N,N,N,N,A,S,RHS)
C
C                   THEN Q (IN JAC^)
C
		    CALL ATBMUL(N,N,1,1,N,N,JAC,RHS,WV3)
		 END IF
		 DMULT=DELFPR/TEN-DELTAF
		 SP=ZERO
		 SS=ZERO
                 DO 2300 K=1,N
                    WV3(K)=WV3(K)+FVECC(K)
                    SP=SP+ABS(FVEC(K)*(FVEC(K)-WV3(K)))
                    SS=SS+(FVEC(K)-WV3(K))*(FVEC(K)-WV3(K))
2300             CONTINUE
		 IF(SP+SQRT(SP*SP+DMULT*SS).LT.EPSMCH) THEN
		    POWLAM=TEN
                 ELSE
		    POWLAM=ONE+DMULT/(SP+SQRT(SP*SP+DMULT*SS))
                 END IF
                 POWLAM=SQRT(POWLAM)
                 POWMU=MIN(DELFAC,POWLAM,POWTAU)
                 POWTAU=POWLAM/POWMU
                 IF(OUTPUT.GT.3) THEN
                    WRITE(NUNIT,1)
		    WRITE(NUNIT,31)
31                  FORMAT(T3,'*',7X,'FACTORS IN POWELL UPDATING',
     $              ' SCHEME',T74,'*')
                    WRITE(NUNIT,1)
		    WRITE(NUNIT,32) POWLAM,POWMU,POWTAU
32                  FORMAT(T3,'*',7X,'LAMBDA: ',1PD12.3,4X,'MU: ',
     $              1PD12.3,4X,'TAU: ',1PD12.3,T74,'*')
		    WRITE(NUNIT,33)
33                  FORMAT(T3,'*',7X,'DELTA IS MINIMUM OF MU*DELTA',
     $              ' AND MAXSTP',T74,'*')
                 END IF
                 DELTA=MIN(POWMU*DELTA,MAXSTP)
              ELSE
		 IF(DELTAF.LT.THREEQ*DELFPR) THEN
                    DELTA=MIN(DELFAC*DELTA,MAXSTP)
                    IF(OUTPUT.GT.3) THEN
                       WRITE(NUNIT,1)
		       WRITE(NUNIT,34)
34                     FORMAT(T3,'*',7X,'CHANGE IN F, DELTAF, IS LESS',
     $                 ' THAN .75 X PREDICTED',T74,'*')
		       WRITE(NUNIT,35) DELTA
35                     FORMAT(T3,'*',7X,'DELTA INCREASED TO: ',1PD12.3,
     $                 T74,'*')
                    END IF
                 ELSE
                    IF(OUTPUT.GT.3) THEN
                       WRITE(NUNIT,1)
		       WRITE(NUNIT,36)
36                     FORMAT(T3,'*',7X,'DELTAF BETWEEN 0.1 AND 0.75',
     $                 ' DELFPR - LEAVE DELTA UNCHANGED',T74,'*')
                    END IF
                 END IF
              END IF
           END IF
        END IF
        RETURN
C
C       LAST CARD OF SUBROUTINE TRSTUP.
C
	END

