	SUBROUTINE UTBMUL(NCADEC,NCAACT,NCBDEC,NCBACT,NCDEC,NCACT,
     $                    AMAT  ,BMAT  ,CMAT)
C
C       FEB. 8, 1991
C
C       MATRIX MULTIPLICATION:   A^B=C    WHERE A IS UPPER TRIANGULAR
C
C       VERSION WITH INNER LOOP UNROLLED TO DEPTHS 32, 16, 8 AND 4.
C
C       NCADEC IS 2ND DIM. OF AMAT; NCAACT IS ACTUAL LIMIT FOR 2ND INDEX
C       NCBDEC IS 2ND DIM. OF BMAT; NCBACT IS ACTUAL LIMIT FOR 2ND INDEX
C       NCDEC IS COMMON DIMENSION OF AMAT & BMAT; NCACT IS ACTUAL LIMIT
C
C       I.E.   NCADEC IS NUMBER OF COLUMNS OF A DECLARED
C              NCBDEC IS NUMBER OF COLUMNS OF B DECLARED
C              NCDEC IS THE NUMBER OF ROWS IN BOTH A AND B DECLARED
C
C       MODIFICATION OF THE MATRIX MULTIPLIER DONATED BY PROF. JAMES
C       MACKINNON, QUEEN'S UNIVERSITY, KINGSTON, ONTARIO, CANADA
C
	IMPLICIT DOUBLE PRECISION (A-H,O-Z)
	DIMENSION AMAT(NCDEC,NCADEC), BMAT(NCDEC,NCBDEC),
     $            CMAT(NCADEC,NCBDEC)
        DATA ZERO /0.0D0/
	DO 100 I=1,NCAACT
C
C          FIND NUMBER OF GROUPS OF SIZE 32, 16 ...
C
	   NEND=MIN(I,NCACT)
C
C          THIS ADJUSTMENT IS REQUIRED WHEN NCACT IS LESS THAN NCAACT.
C
	   NCC32=NEND/32
	   NCC32R=NEND-32*NCC32
	   NCC16=NCC32R/16
	   NCC16R=NCC32R-16*NCC16
	   NCC8=NCC16R/8
	   NCC8R=NCC16R-8*NCC8
	   NCC4=NCC8R/4
	   NCC4R=NCC8R-4*NCC4
C
C          FIND ENTRY IN MATRIX C.
C
	   DO 200 J=1,NCBACT
	      SUM=ZERO
	      K=0
	      IF(NCC32.GT.0) THEN
		 DO 300 KK=1,NCC32
		    K=K+32
		    SUM=SUM
     $              +AMAT(K-31,I)*BMAT(K-31,J)+AMAT(K-30,I)*BMAT(K-30,J)
     $              +AMAT(K-29,I)*BMAT(K-29,J)+AMAT(K-28,I)*BMAT(K-28,J)
     $              +AMAT(K-27,I)*BMAT(K-27,J)+AMAT(K-26,I)*BMAT(K-26,J)
     $              +AMAT(K-25,I)*BMAT(K-25,J)+AMAT(K-24,I)*BMAT(K-24,J)
		    SUM=SUM
     $              +AMAT(K-23,I)*BMAT(K-23,J)+AMAT(K-22,I)*BMAT(K-22,J)
     $              +AMAT(K-21,I)*BMAT(K-21,J)+AMAT(K-20,I)*BMAT(K-20,J)
     $              +AMAT(K-19,I)*BMAT(K-19,J)+AMAT(K-18,I)*BMAT(K-18,J)
     $              +AMAT(K-17,I)*BMAT(K-17,J)+AMAT(K-16,I)*BMAT(K-16,J)
		    SUM=SUM
     $              +AMAT(K-15,I)*BMAT(K-15,J)+AMAT(K-14,I)*BMAT(K-14,J)
     $              +AMAT(K-13,I)*BMAT(K-13,J)+AMAT(K-12,I)*BMAT(K-12,J)
     $              +AMAT(K-11,I)*BMAT(K-11,J)+AMAT(K-10,I)*BMAT(K-10,J)
     $              +AMAT(K-9,I) *BMAT(K-9,J) +AMAT(K-8,I) *BMAT(K-8,J)
		    SUM=SUM
     $              +AMAT(K-7,I)*BMAT(K-7,J)+AMAT(K-6,I)*BMAT(K-6,J)
     $              +AMAT(K-5,I)*BMAT(K-5,J)+AMAT(K-4,I)*BMAT(K-4,J)
     $              +AMAT(K-3,I)*BMAT(K-3,J)+AMAT(K-2,I)*BMAT(K-2,J)
     $              +AMAT(K-1,I)*BMAT(K-1,J)+AMAT(K,I)  *BMAT(K,J)
300              CONTINUE
	      END IF
	      IF(NCC16.GT.0) THEN
		 DO 400 KK=1,NCC16
		    K=K+16
		    SUM=SUM
     $              +AMAT(K-15,I)*BMAT(K-15,J)+AMAT(K-14,I)*BMAT(K-14,J)
     $              +AMAT(K-13,I)*BMAT(K-13,J)+AMAT(K-12,I)*BMAT(K-12,J)
     $              +AMAT(K-11,I)*BMAT(K-11,J)+AMAT(K-10,I)*BMAT(K-10,J)
     $              +AMAT(K-9,I)*BMAT(K-9,J)  +AMAT(K-8,I) *BMAT(K-8,J)
		    SUM=SUM
     $              +AMAT(K-7,I)*BMAT(K-7,J)+AMAT(K-6,I)*BMAT(K-6,J)
     $              +AMAT(K-5,I)*BMAT(K-5,J)+AMAT(K-4,I)*BMAT(K-4,J)
     $              +AMAT(K-3,I)*BMAT(K-3,J)+AMAT(K-2,I)*BMAT(K-2,J)
     $              +AMAT(K-1,I)*BMAT(K-1,J)+AMAT(K,I)  *BMAT(K,J)
400              CONTINUE
	      END IF
	      IF(NCC8.GT.0) THEN
		 DO 500 KK=1,NCC8
		    K=K+8
		    SUM=SUM
     $              +AMAT(K-7,I)*BMAT(K-7,J)+AMAT(K-6,I)*BMAT(K-6,J)
     $              +AMAT(K-5,I)*BMAT(K-5,J)+AMAT(K-4,I)*BMAT(K-4,J)
     $              +AMAT(K-3,I)*BMAT(K-3,J)+AMAT(K-2,I)*BMAT(K-2,J)
     $              +AMAT(K-1,I)*BMAT(K-1,J)+AMAT(K,I)  *BMAT(K,J)
500              CONTINUE
	      END IF
	      IF(NCC4.GT.0) THEN
		 DO 600 KK=1,NCC4
		    K=K+4
		    SUM=SUM
     $              +AMAT(K-3,I)*BMAT(K-3,J)+AMAT(K-2,I)*BMAT(K-2,J)
     $              +AMAT(K-1,I)*BMAT(K-1,J)+AMAT(K,I)  *BMAT(K,J)
600              CONTINUE
	      END IF
	      IF(NCC4R.GT.0) THEN
		 DO 700 KK=1,NCC4R
		    K=K+1
		    SUM=SUM+AMAT(K,I)*BMAT(K,J)
700              CONTINUE
	      END IF
	      CMAT(I,J)=SUM
200        CONTINUE
100     CONTINUE
	RETURN
C
C       LAST CARD OF SUBROUTINE UTBMUL.
C
	END
