// This may look like C code, but it is really -*- C++ -*-
// Contains routines for analysis of a piezoelectric strain // gauge
//                       	+---------+
//                      	|         |
//             0  o------+         +-------o 1
//                       |         |
//     Mechanical        +----+----+         Electrical
//                            |
//                o-----------+------------o 2
// Author:
// Jonathan Cantor and Richard McMunn
//
#ifndef StrainGauge_h
#define StrainGauge_h 1

class StrainGauge : public AdolcElement
{
public:

  StrainGauge(const string& iname);
  
~StrainGauge() {}

  static const char* getNetlistName()
  {
    return einfo.name;
  }

  virtual void init() throw(string&);

private:

  virtual void eval(adoublev& x,
		    adoublev& vp, adoublev& ip);
  static ItemInfo einfo;
  static const unsigned n_par;
  double h1,h2,h3,C,e,eps;
  static ParmInfo pinfo[];
};
#endif
