// This is a Comprehensive VCSEL Model
//
// by Houssam Kanj

#ifndef VCSEL_h
#define VCSEL_h 1

class VCSEL : public AdolcElement
{
	public:

  VCSEL(const string& iname);

  ~VCSEL() {}

  static const char* getNetlistName()
  {
    return einfo.name;
  }

  virtual void init() throw(string&);

  virtual void getLocalRefIdx(UnsignedVector& local_ref_vec,
	TerminalVector& term_list);

	private:

  virtual void eval(adoublev& x, adoublev& vp, adoublev& ip);

  // Element information
  static ItemInfo einfo;

  // Number of parameters of this element
  static const unsigned n_par;

  // Parameter variables
	double etai, beta, tn, k, g0, n0, tp, a0, a1, a2, a3, a4, rho, n, lambda0;
	double rth, tth, t0;

  // Parameter information
  static ParmInfo pinfo[];
};

#endif

